/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs


/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static inline void
reset_passwords(void)
{
 this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}


/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->stub != 0))
    cf_error( "Backbone area cannot be stub");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
     backbone = 1;
  }
  cf->abr = areano > 1;

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error( "No configured areas in OSPF");
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from ../../proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix

static struct radv_prefix_config *this_radv_prefix;

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;



/* Line 268 of yacc.c  */
#line 357 "cf-parse.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     DDOT = 262,
     GEQ = 263,
     LEQ = 264,
     NEQ = 265,
     AND = 266,
     OR = 267,
     PO = 268,
     PC = 269,
     NUM = 270,
     ENUM = 271,
     RTRID = 272,
     IPA = 273,
     SYM = 274,
     TEXT = 275,
     PREFIX_DUMMY = 276,
     DEFINE = 277,
     ON = 278,
     OFF = 279,
     YES = 280,
     NO = 281,
     LOG = 282,
     SYSLOG = 283,
     ALL = 284,
     DEBUG = 285,
     TRACE = 286,
     INFO = 287,
     REMOTE = 288,
     WARNING = 289,
     ERROR = 290,
     AUTH = 291,
     FATAL = 292,
     BUG = 293,
     STDERR = 294,
     SOFT = 295,
     TIMEFORMAT = 296,
     ISO = 297,
     SHORT = 298,
     LONG = 299,
     BASE = 300,
     NAME = 301,
     CONFIGURE = 302,
     DOWN = 303,
     KERNEL = 304,
     PERSIST = 305,
     SCAN = 306,
     TIME = 307,
     LEARN = 308,
     DEVICE = 309,
     ROUTES = 310,
     ASYNC = 311,
     TABLE = 312,
     KRT_PREFSRC = 313,
     KRT_REALM = 314,
     ROUTER = 315,
     ID = 316,
     PROTOCOL = 317,
     PREFERENCE = 318,
     DISABLED = 319,
     DIRECT = 320,
     INTERFACE = 321,
     IMPORT = 322,
     EXPORT = 323,
     FILTER = 324,
     NONE = 325,
     STATES = 326,
     FILTERS = 327,
     PASSWORD = 328,
     FROM = 329,
     PASSIVE = 330,
     TO = 331,
     EVENTS = 332,
     PACKETS = 333,
     PROTOCOLS = 334,
     INTERFACES = 335,
     PRIMARY = 336,
     STATS = 337,
     COUNT = 338,
     FOR = 339,
     COMMANDS = 340,
     PREEXPORT = 341,
     GENERATE = 342,
     LISTEN = 343,
     BGP = 344,
     V6ONLY = 345,
     DUAL = 346,
     ADDRESS = 347,
     PORT = 348,
     PASSWORDS = 349,
     DESCRIPTION = 350,
     RELOAD = 351,
     IN = 352,
     OUT = 353,
     MRTDUMP = 354,
     MESSAGES = 355,
     RESTRICT = 356,
     MEMORY = 357,
     IGP_METRIC = 358,
     SHOW = 359,
     STATUS = 360,
     SUMMARY = 361,
     ROUTE = 362,
     SYMBOLS = 363,
     DUMP = 364,
     RESOURCES = 365,
     SOCKETS = 366,
     NEIGHBORS = 367,
     ATTRIBUTES = 368,
     ECHO = 369,
     DISABLE = 370,
     ENABLE = 371,
     RESTART = 372,
     FUNCTION = 373,
     PRINT = 374,
     PRINTN = 375,
     UNSET = 376,
     RETURN = 377,
     ACCEPT = 378,
     REJECT = 379,
     QUITBIRD = 380,
     INT = 381,
     BOOL = 382,
     IP = 383,
     PREFIX = 384,
     PAIR = 385,
     QUAD = 386,
     SET = 387,
     STRING = 388,
     BGPMASK = 389,
     BGPPATH = 390,
     CLIST = 391,
     IF = 392,
     THEN = 393,
     ELSE = 394,
     CASE = 395,
     TRUE = 396,
     FALSE = 397,
     GW = 398,
     NET = 399,
     MASK = 400,
     PROTO = 401,
     SOURCE = 402,
     SCOPE = 403,
     CAST = 404,
     DEST = 405,
     LEN = 406,
     DEFINED = 407,
     ADD = 408,
     DELETE = 409,
     CONTAINS = 410,
     RESET = 411,
     PREPEND = 412,
     FIRST = 413,
     LAST = 414,
     MATCH = 415,
     EMPTY = 416,
     WHERE = 417,
     EVAL = 418,
     LOCAL = 419,
     NEIGHBOR = 420,
     AS = 421,
     HOLD = 422,
     CONNECT = 423,
     RETRY = 424,
     KEEPALIVE = 425,
     MULTIHOP = 426,
     STARTUP = 427,
     VIA = 428,
     NEXT = 429,
     HOP = 430,
     SELF = 431,
     DEFAULT = 432,
     PATH = 433,
     METRIC = 434,
     START = 435,
     DELAY = 436,
     FORGET = 437,
     WAIT = 438,
     AFTER = 439,
     BGP_PATH = 440,
     BGP_LOCAL_PREF = 441,
     BGP_MED = 442,
     BGP_ORIGIN = 443,
     BGP_NEXT_HOP = 444,
     BGP_ATOMIC_AGGR = 445,
     BGP_AGGREGATOR = 446,
     BGP_COMMUNITY = 447,
     RR = 448,
     RS = 449,
     CLIENT = 450,
     CLUSTER = 451,
     AS4 = 452,
     ADVERTISE = 453,
     IPV4 = 454,
     CAPABILITIES = 455,
     LIMIT = 456,
     PREFER = 457,
     OLDER = 458,
     MISSING = 459,
     LLADDR = 460,
     DROP = 461,
     IGNORE = 462,
     REFRESH = 463,
     INTERPRET = 464,
     COMMUNITIES = 465,
     BGP_ORIGINATOR_ID = 466,
     BGP_CLUSTER_LIST = 467,
     IGP = 468,
     GATEWAY = 469,
     RECURSIVE = 470,
     MED = 471,
     OSPF = 472,
     AREA = 473,
     OSPF_METRIC1 = 474,
     OSPF_METRIC2 = 475,
     OSPF_TAG = 476,
     OSPF_ROUTER_ID = 477,
     RFC1583COMPAT = 478,
     STUB = 479,
     TICK = 480,
     COST = 481,
     RETRANSMIT = 482,
     HELLO = 483,
     TRANSMIT = 484,
     PRIORITY = 485,
     DEAD = 486,
     TYPE = 487,
     BROADCAST = 488,
     BCAST = 489,
     NONBROADCAST = 490,
     NBMA = 491,
     POINTOPOINT = 492,
     PTP = 493,
     POINTOMULTIPOINT = 494,
     PTMP = 495,
     SIMPLE = 496,
     AUTHENTICATION = 497,
     STRICT = 498,
     CRYPTOGRAPHIC = 499,
     ELIGIBLE = 500,
     POLL = 501,
     NETWORKS = 502,
     HIDDEN = 503,
     VIRTUAL = 504,
     CHECK = 505,
     LINK = 506,
     RX = 507,
     BUFFER = 508,
     LARGE = 509,
     NORMAL = 510,
     STUBNET = 511,
     LSADB = 512,
     ECMP = 513,
     WEIGHT = 514,
     TOPOLOGY = 515,
     STATE = 516,
     PIPE = 517,
     PEER = 518,
     MODE = 519,
     OPAQUE = 520,
     TRANSPARENT = 521,
     RADV = 522,
     MIN = 523,
     MAX = 524,
     RA = 525,
     INTERVAL = 526,
     MANAGED = 527,
     OTHER = 528,
     CONFIG = 529,
     MTU = 530,
     REACHABLE = 531,
     RETRANS = 532,
     TIMER = 533,
     CURRENT = 534,
     VALID = 535,
     PREFERRED = 536,
     LIFETIME = 537,
     SKIP = 538,
     ONLINK = 539,
     AUTONOMOUS = 540,
     RIP = 541,
     INFINITY = 542,
     PERIOD = 543,
     GARBAGE = 544,
     TIMEOUT = 545,
     MULTICAST = 546,
     QUIET = 547,
     NOLISTEN = 548,
     VERSION1 = 549,
     PLAINTEXT = 550,
     MD5 = 551,
     HONOR = 552,
     NEVER = 553,
     ALWAYS = 554,
     RIP_METRIC = 555,
     RIP_TAG = 556,
     STATIC = 557,
     PROHIBIT = 558,
     MULTIPATH = 559
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 280 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;



/* Line 293 of yacc.c  */
#line 721 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 733 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  54
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2100

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  326
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  222
/* YYNRULES -- Number of rules.  */
#define YYNRULES  687
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1289

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   559

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     316,   317,    28,    26,   322,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   319,   318,
      23,    22,    24,   323,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   324,     2,   325,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   320,     2,   321,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    15,    19,    21,
      27,    33,    35,    37,    39,    41,    43,    44,    46,    48,
      51,    53,    55,    58,    61,    63,    65,    66,    71,    74,
      75,    77,    80,    82,    84,    88,    90,    94,    96,    98,
     100,   102,   104,   106,   108,   110,   112,   117,   121,   123,
     125,   127,   129,   132,   137,   141,   145,   149,   153,   158,
     161,   162,   164,   167,   170,   174,   177,   181,   184,   188,
     192,   196,   201,   203,   205,   207,   212,   213,   216,   219,
     222,   224,   226,   229,   231,   232,   234,   235,   238,   241,
     244,   247,   250,   253,   256,   260,   263,   266,   268,   270,
     272,   274,   278,   282,   283,   285,   287,   290,   291,   293,
     297,   299,   303,   306,   310,   314,   318,   319,   323,   325,
     327,   331,   333,   337,   339,   341,   343,   345,   347,   349,
     351,   353,   357,   359,   363,   365,   367,   372,   374,   375,
     379,   384,   386,   389,   390,   396,   402,   408,   414,   419,
     423,   427,   432,   438,   440,   441,   445,   450,   455,   456,
     459,   463,   467,   471,   474,   477,   480,   484,   488,   491,
     494,   496,   498,   503,   507,   511,   515,   519,   523,   527,
     531,   536,   538,   540,   542,   543,   545,   549,   553,   557,
     561,   566,   571,   576,   581,   584,   586,   588,   590,   592,
     593,   595,   596,   601,   604,   606,   608,   610,   612,   614,
     616,   618,   620,   622,   624,   627,   630,   631,   635,   637,
     641,   643,   645,   647,   650,   654,   657,   662,   663,   669,
     670,   672,   674,   677,   679,   683,   685,   687,   689,   691,
     693,   695,   699,   701,   703,   705,   707,   709,   713,   715,
     721,   733,   735,   737,   741,   743,   745,   749,   751,   755,
     757,   761,   765,   767,   770,   773,   780,   782,   786,   787,
     792,   796,   798,   802,   806,   810,   813,   816,   819,   822,
     823,   826,   829,   830,   836,   838,   840,   842,   844,   846,
     848,   850,   854,   858,   860,   862,   863,   868,   870,   872,
     874,   876,   878,   880,   882,   884,   886,   890,   894,   898,
     902,   906,   910,   914,   918,   922,   926,   930,   934,   938,
     942,   945,   950,   952,   954,   956,   958,   961,   964,   968,
     972,   979,   983,   987,   991,   995,  1002,  1009,  1016,  1023,
    1028,  1030,  1032,  1034,  1036,  1038,  1040,  1042,  1043,  1045,
    1049,  1051,  1055,  1056,  1058,  1063,  1070,  1075,  1079,  1085,
    1091,  1096,  1103,  1107,  1110,  1116,  1122,  1131,  1140,  1149,
    1158,  1161,  1165,  1169,  1175,  1182,  1189,  1196,  1201,  1206,
    1212,  1219,  1226,  1232,  1236,  1241,  1247,  1253,  1259,  1265,
    1270,  1275,  1281,  1287,  1293,  1299,  1305,  1311,  1317,  1324,
    1331,  1340,  1347,  1354,  1360,  1365,  1371,  1376,  1382,  1387,
    1393,  1399,  1402,  1406,  1410,  1412,  1415,  1418,  1423,  1426,
    1428,  1431,  1436,  1437,  1441,  1445,  1448,  1453,  1456,  1459,
    1461,  1466,  1468,  1470,  1471,  1475,  1478,  1481,  1484,  1489,
    1491,  1492,  1496,  1497,  1500,  1503,  1507,  1510,  1513,  1517,
    1520,  1523,  1526,  1528,  1532,  1535,  1538,  1541,  1544,  1547,
    1550,  1554,  1557,  1560,  1563,  1566,  1569,  1572,  1575,  1578,
    1582,  1585,  1589,  1592,  1596,  1600,  1605,  1608,  1611,  1614,
    1618,  1622,  1626,  1628,  1629,  1632,  1634,  1636,  1639,  1643,
    1644,  1647,  1649,  1651,  1654,  1658,  1659,  1660,  1664,  1665,
    1669,  1673,  1675,  1676,  1681,  1688,  1695,  1702,  1710,  1717,
    1725,  1732,  1735,  1739,  1743,  1749,  1754,  1759,  1762,  1764,
    1767,  1770,  1771,  1775,  1780,  1781,  1786,  1791,  1795,  1798,
    1802,  1806,  1810,  1814,  1819,  1823,  1826,  1827,  1828,  1832,
    1833,  1837,  1842,  1844,  1847,  1850,  1853,  1857,  1861,  1862,
    1863,  1867,  1868,  1872,  1876,  1879,  1883,  1887,  1892,  1897,
    1902,  1908,  1914,  1919,  1923,  1928,  1933,  1938,  1943,  1945,
    1947,  1949,  1951,  1953,  1955,  1957,  1959,  1960,  1963,  1966,
    1967,  1971,  1972,  1976,  1977,  1981,  1984,  1988,  1992,  1998,
    2002,  2005,  2008,  2012,  2014,  2017,  2021,  2025,  2029,  2032,
    2035,  2038,  2043,  2045,  2047,  2049,  2051,  2053,  2055,  2057,
    2059,  2061,  2063,  2065,  2067,  2069,  2071,  2073,  2075,  2077,
    2079,  2081,  2083,  2085,  2087,  2089,  2091,  2093,  2095,  2097,
    2099,  2101,  2103,  2105,  2107,  2109,  2111,  2113,  2115,  2117,
    2119,  2121,  2123,  2125,  2127,  2129,  2131,  2133,  2135,  2137,
    2139,  2141,  2143,  2146,  2149,  2152,  2155,  2158,  2161,  2164,
    2167,  2170,  2174,  2178,  2182,  2186,  2190,  2194,  2198,  2200,
    2202,  2204,  2206,  2208,  2210,  2212,  2214,  2216,  2218,  2220,
    2222,  2224,  2226,  2228,  2230,  2232,  2234,  2236
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     327,     0,    -1,   328,     3,    -1,     4,   543,    -1,    -1,
     328,   542,    -1,    15,    -1,   316,   462,   317,    -1,    19,
      -1,    33,    19,    22,   329,   318,    -1,    33,    19,    22,
      18,   318,    -1,   329,    -1,    34,    -1,    36,    -1,    35,
      -1,    37,    -1,    -1,    18,    -1,    19,    -1,   332,   335,
      -1,   333,    -1,   332,    -1,    29,   329,    -1,   319,   332,
      -1,    20,    -1,    20,    -1,    -1,    38,   340,   341,   318,
      -1,    57,    20,    -1,    -1,    20,    -1,    39,   339,    -1,
      50,    -1,    40,    -1,   320,   342,   321,    -1,   343,    -1,
     342,   322,   343,    -1,    41,    -1,    42,    -1,    43,    -1,
      44,    -1,    45,    -1,    46,    -1,    47,    -1,    48,    -1,
      49,    -1,   110,    90,   381,   318,    -1,   110,    20,   318,
      -1,   118,    -1,    73,    -1,    56,    -1,    38,    -1,   345,
      20,    -1,   345,    20,   329,    20,    -1,   345,    53,    54,
      -1,   345,    53,    55,    -1,    52,   346,   318,    -1,    58,
     351,     3,    -1,    58,    51,   351,     3,    -1,    59,     3,
      -1,    -1,    20,    -1,   363,    60,    -1,    61,   331,    -1,
      62,    63,   329,    -1,    64,   331,    -1,    65,    66,   331,
      -1,   363,    65,    -1,    62,    63,   329,    -1,    92,   337,
     334,    -1,    60,    68,   329,    -1,    71,    72,   358,   318,
      -1,    15,    -1,    17,    -1,    18,    -1,    99,   100,   360,
     318,    -1,    -1,   360,   361,    -1,   103,   332,    -1,   104,
     329,    -1,   101,    -1,   102,    -1,    68,    19,    -1,    73,
      -1,    -1,    19,    -1,    -1,    74,   329,    -1,    75,   331,
      -1,    41,   378,    -1,   110,   381,    -1,    78,   366,    -1,
      79,   366,    -1,    68,   367,    -1,    71,    72,   358,    -1,
     106,    20,    -1,    80,   429,    -1,   430,    -1,    40,    -1,
      81,    -1,    19,    -1,    41,    90,   378,    -1,    41,    96,
     329,    -1,    -1,    20,    -1,   334,    -1,    20,   334,    -1,
      -1,    27,    -1,   369,   371,   370,    -1,   372,    -1,   373,
     322,   372,    -1,   363,    76,    -1,   374,   364,   320,    -1,
     375,   365,   318,    -1,   375,   377,   318,    -1,    -1,    77,
     376,   373,    -1,    40,    -1,    35,    -1,   320,   379,   321,
      -1,   380,    -1,   379,   322,   380,    -1,    82,    -1,    66,
      -1,    83,    -1,    91,    -1,    88,    -1,    89,    -1,    40,
      -1,    35,    -1,   320,   382,   321,    -1,   383,    -1,   382,
     322,   383,    -1,    82,    -1,   111,    -1,   105,   320,   385,
     321,    -1,   386,    -1,    -1,   386,   318,   385,    -1,   387,
     320,   388,   321,    -1,   387,    -1,    84,    20,    -1,    -1,
      98,    85,   336,   318,   388,    -1,    98,    87,   336,   318,
     388,    -1,   134,    85,   336,   318,   388,    -1,   134,    87,
     336,   318,   388,    -1,    72,   329,   318,   388,    -1,   115,
     116,     3,    -1,   115,   113,     3,    -1,   115,    90,   420,
       3,    -1,   115,    90,    40,   420,     3,    -1,    19,    -1,
      -1,   115,    91,     3,    -1,   115,    91,   117,     3,    -1,
     115,   118,   397,     3,    -1,    -1,   397,   333,    -1,   397,
      95,   334,    -1,   397,    68,    19,    -1,   397,    80,   429,
      -1,   397,   430,    -1,   397,    40,    -1,   397,    92,    -1,
     397,   398,    19,    -1,   397,    73,    19,    -1,   397,    93,
      -1,   397,    94,    -1,    97,    -1,    79,    -1,   115,   119,
     393,     3,    -1,   120,   121,     3,    -1,   120,   122,     3,
      -1,   120,    91,     3,    -1,   120,   123,     3,    -1,   120,
     124,     3,    -1,   120,    66,     3,    -1,   120,    90,     3,
      -1,   125,   408,   409,     3,    -1,    40,    -1,    35,    -1,
      15,    -1,    -1,    15,    -1,   126,   419,     3,    -1,   127,
     419,     3,    -1,   128,   419,     3,    -1,   107,   419,     3,
      -1,   107,   108,   419,     3,    -1,   107,   109,   419,     3,
      -1,    41,   419,   378,     3,    -1,   110,   419,   381,     3,
      -1,   112,     3,    -1,    19,    -1,    40,    -1,    20,    -1,
      19,    -1,    -1,    20,    -1,    -1,    80,    19,   422,   428,
      -1,   174,   462,    -1,   137,    -1,   138,    -1,   139,    -1,
     140,    -1,   141,    -1,   142,    -1,   144,    -1,   145,    -1,
     146,    -1,   147,    -1,   424,   143,    -1,   424,    19,    -1,
      -1,   425,   318,   426,    -1,   425,    -1,   427,   318,   425,
      -1,   432,    -1,    19,    -1,   428,    -1,   173,   462,    -1,
     316,   427,   317,    -1,   316,   317,    -1,   426,   320,   435,
     321,    -1,    -1,   129,    19,   434,   431,   432,    -1,    -1,
     436,    -1,   468,    -1,   436,   468,    -1,   468,    -1,   320,
     435,   321,    -1,    18,    -1,   329,    -1,    17,    -1,   438,
      -1,    16,    -1,    15,    -1,   316,   462,   317,    -1,    17,
      -1,   438,    -1,    16,    -1,   462,    -1,   441,    -1,   441,
       7,   441,    -1,    28,    -1,   316,   442,   322,   442,   317,
      -1,   316,   442,   322,   442,   317,     7,   316,   441,   322,
     441,   317,    -1,   443,    -1,   439,    -1,   439,     7,   439,
      -1,   443,    -1,   440,    -1,   440,     7,   440,    -1,   444,
      -1,   446,   322,   444,    -1,   445,    -1,   447,   322,   445,
      -1,    18,    29,    15,    -1,   448,    -1,   448,    26,    -1,
     448,    27,    -1,   448,   320,    15,   322,    15,   321,    -1,
     449,    -1,   450,   322,   449,    -1,    -1,   451,   447,   319,
     435,    -1,   451,     6,   435,    -1,   460,    -1,   316,   462,
     317,    -1,    13,   454,    14,    -1,    29,   455,    29,    -1,
      15,   454,    -1,    28,   454,    -1,   323,   454,    -1,   452,
     454,    -1,    -1,    15,   455,    -1,   323,   455,    -1,    -1,
     316,   462,   322,   462,   317,    -1,    15,    -1,   152,    -1,
     153,    -1,    20,    -1,   438,    -1,   448,    -1,    17,    -1,
     324,   446,   325,    -1,   324,   450,   325,    -1,    16,    -1,
     453,    -1,    -1,    19,   316,   467,   317,    -1,    19,    -1,
      85,    -1,   154,    -1,   155,    -1,   157,    -1,   158,    -1,
     159,    -1,   160,    -1,   161,    -1,   316,   462,   317,    -1,
     462,    26,   462,    -1,   462,    27,   462,    -1,   462,    28,
     462,    -1,   462,    29,   462,    -1,   462,    11,   462,    -1,
     462,    12,   462,    -1,   462,    22,   462,    -1,   462,    10,
     462,    -1,   462,    23,   462,    -1,   462,     9,   462,    -1,
     462,    24,   462,    -1,   462,     8,   462,    -1,   462,    25,
     462,    -1,    31,   462,    -1,   163,   316,   462,   317,    -1,
     460,    -1,   457,    -1,   456,    -1,    74,    -1,   458,   461,
      -1,   458,   547,    -1,   462,    32,   139,    -1,   462,    32,
     162,    -1,   462,    32,   156,   316,   462,   317,    -1,   462,
      32,   169,    -1,   462,    32,   170,    -1,    26,   172,    26,
      -1,    27,   172,    27,    -1,   168,   316,   462,   322,   462,
     317,    -1,   164,   316,   462,   322,   462,   317,    -1,   165,
     316,   462,   322,   462,   317,    -1,    80,   316,   462,   322,
     462,   317,    -1,    19,   316,   467,   317,    -1,   136,    -1,
     134,    -1,   135,    -1,    46,    -1,   130,    -1,   131,    -1,
     462,    -1,    -1,   464,    -1,   464,   322,   465,    -1,   462,
      -1,   462,   322,   466,    -1,    -1,   466,    -1,   148,   462,
     149,   437,    -1,   148,   462,   149,   437,   150,   437,    -1,
      19,    22,   462,   318,    -1,   133,   462,   318,    -1,   458,
     547,    22,   462,   318,    -1,   458,   461,    22,   462,   318,
      -1,    74,    22,   462,   318,    -1,   132,   316,   458,   547,
     317,   318,    -1,   463,   465,   318,    -1,   459,   318,    -1,
     151,   462,   320,   451,   321,    -1,   458,   547,    32,   172,
     318,    -1,   458,   547,    32,   168,   316,   462,   317,   318,
      -1,   458,   547,    32,   164,   316,   462,   317,   318,    -1,
     458,   547,    32,   165,   316,   462,   317,   318,    -1,   458,
     547,    32,    80,   316,   462,   317,   318,    -1,   363,   100,
      -1,   469,   364,   320,    -1,   470,   365,   318,    -1,   470,
     175,   177,   329,   318,    -1,   470,   175,   332,   177,   329,
     318,    -1,   470,   176,   332,   177,   329,   318,    -1,   470,
     204,   207,    72,   358,   318,    -1,   470,   204,   206,   318,
      -1,   470,   205,   206,   318,    -1,   470,   178,    63,   329,
     318,    -1,   470,   183,   178,    63,   329,   318,    -1,   470,
     179,   180,    63,   329,   318,    -1,   470,   181,    63,   329,
     318,    -1,   470,   182,   318,    -1,   470,   182,   329,   318,
      -1,   470,   185,   186,   187,   318,    -1,   470,   215,   216,
     187,   318,    -1,   470,   215,   216,   217,   318,    -1,   470,
     215,   216,   218,   318,    -1,   470,   225,    76,   318,    -1,
     470,   225,   226,   318,    -1,   470,   189,   190,   331,   318,
      -1,   470,   227,   190,   331,   318,    -1,   470,   224,   190,
     331,   318,    -1,   470,   213,   214,   331,   318,    -1,   470,
     188,   198,   329,   318,    -1,   470,   188,   197,   329,   318,
      -1,   470,   158,   103,   332,   318,    -1,   470,   191,   192,
      63,   329,   318,    -1,   470,    46,   193,    63,   329,   318,
      -1,   470,    46,   194,    63,   329,   322,   329,   318,    -1,
     470,   126,   195,    46,   331,   318,    -1,   470,   127,   118,
     219,   331,   318,    -1,   470,   127,   208,   331,   318,    -1,
     470,   211,   331,   318,    -1,   470,   209,   210,   331,   318,
      -1,   470,    84,    20,   318,    -1,   470,   118,   212,   329,
     318,    -1,   470,    86,   331,   318,    -1,   470,   220,   221,
     331,   318,    -1,   470,   224,    68,   367,   318,    -1,   363,
     228,    -1,   471,   364,   320,    -1,   472,   473,   318,    -1,
     365,    -1,   234,   331,    -1,   269,   331,    -1,   269,   331,
     212,   329,    -1,   236,   329,    -1,   475,    -1,   229,   358,
      -1,   474,   320,   476,   321,    -1,    -1,   476,   477,   318,
      -1,   235,   237,   329,    -1,   235,   331,    -1,   258,   320,
     487,   321,    -1,   267,   478,    -1,    77,   498,    -1,   482,
      -1,   479,   320,   480,   321,    -1,   479,    -1,   333,    -1,
      -1,   480,   481,   318,    -1,   259,   331,    -1,   117,   331,
      -1,   237,   329,    -1,   485,   320,   483,   321,    -1,   485,
      -1,    -1,   483,   484,   318,    -1,    -1,   239,   329,    -1,
     238,   329,    -1,   240,   192,   329,    -1,   194,   329,    -1,
     242,   329,    -1,   242,    94,   329,    -1,   253,    81,    -1,
     253,   252,    -1,   253,   255,    -1,   384,    -1,   260,   262,
     358,    -1,   237,   329,    -1,   239,   329,    -1,   257,   329,
      -1,   238,   329,    -1,   194,   329,    -1,   242,   329,    -1,
     242,    94,   329,    -1,   243,   244,    -1,   243,   245,    -1,
     243,   246,    -1,   243,   247,    -1,   243,   248,    -1,   243,
     249,    -1,   243,   250,    -1,   243,   251,    -1,   240,   192,
     329,    -1,   241,   329,    -1,   254,   246,   331,    -1,   235,
     331,    -1,   261,   262,   331,    -1,   269,   270,   329,    -1,
     123,   320,   491,   321,    -1,   253,    81,    -1,   253,   252,
      -1,   253,   255,    -1,   263,   264,   265,    -1,   263,   264,
     266,    -1,   263,   264,   329,    -1,   384,    -1,    -1,   487,
     488,    -1,   489,    -1,   490,    -1,   333,   318,    -1,   333,
     259,   318,    -1,    -1,   491,   492,    -1,   493,    -1,   494,
      -1,    18,   318,    -1,    18,   256,   318,    -1,    -1,    -1,
     496,   486,   318,    -1,    -1,   320,   496,   321,    -1,   495,
     373,   497,    -1,    20,    -1,    -1,   115,   228,   393,     3,
      -1,   115,   228,   123,   393,   499,     3,    -1,   115,   228,
      77,   393,   499,     3,    -1,   115,   228,   271,   393,   499,
       3,    -1,   115,   228,   271,    40,   393,   499,     3,    -1,
     115,   228,   272,   393,   499,     3,    -1,   115,   228,   272,
      40,   393,   499,     3,    -1,   115,   228,   268,   393,   499,
       3,    -1,   363,   273,    -1,   508,   364,   320,    -1,   509,
     365,   318,    -1,   509,   274,    68,    19,   318,    -1,   509,
     275,   276,   318,    -1,   509,   275,   277,   318,    -1,   363,
     278,    -1,   365,    -1,   140,   525,    -1,    77,   519,    -1,
      -1,   512,   511,   318,    -1,   510,   364,   320,   512,    -1,
      -1,   279,   281,   282,   329,    -1,   280,   281,   282,   329,
      -1,   279,   192,   329,    -1,   283,   331,    -1,   284,   285,
     331,    -1,   262,   286,   329,    -1,   287,    63,   329,    -1,
     288,   289,   329,    -1,   290,   186,   212,   329,    -1,   188,
     293,   329,    -1,   140,   525,    -1,    -1,    -1,   517,   515,
     318,    -1,    -1,   320,   517,   321,    -1,   514,   373,   518,
     516,    -1,   333,    -1,   294,   331,    -1,   295,   331,    -1,
     296,   331,    -1,   291,   293,   329,    -1,   292,   293,   329,
      -1,    -1,    -1,   523,   521,   318,    -1,    -1,   320,   523,
     321,    -1,   520,   524,   522,    -1,   363,   297,    -1,   526,
     364,   320,    -1,   527,   365,   318,    -1,   527,   298,   329,
     318,    -1,   527,   104,   329,   318,    -1,   527,   299,   329,
     318,    -1,   527,   300,    63,   329,   318,    -1,   527,   301,
      63,   329,   318,    -1,   527,   253,   528,   318,    -1,   527,
     384,   318,    -1,   527,   308,   310,   318,    -1,   527,   308,
     176,   318,    -1,   527,   308,   309,   318,    -1,   527,    77,
     534,   318,    -1,   306,    -1,   307,    -1,    81,    -1,   244,
      -1,   302,    -1,   303,    -1,   304,    -1,   305,    -1,    -1,
     190,   329,    -1,   275,   529,    -1,    -1,   531,   530,   318,
      -1,    -1,   320,   531,   321,    -1,    -1,   533,   373,   532,
      -1,   363,   313,    -1,   535,   364,   320,    -1,   536,   365,
     318,    -1,   536,   261,   262,   331,   318,    -1,   536,   540,
     318,    -1,   118,   333,    -1,   184,   332,    -1,   538,   270,
     329,    -1,   538,    -1,   539,   538,    -1,   537,   184,   332,
      -1,   537,   184,    20,    -1,   537,   315,   539,    -1,   537,
     217,    -1,   537,   135,    -1,   537,   314,    -1,   115,   313,
     393,     3,    -1,   318,    -1,   330,    -1,   338,    -1,   344,
      -1,   347,    -1,   357,    -1,   359,    -1,   362,    -1,   544,
      -1,   368,    -1,   421,    -1,   423,    -1,   433,    -1,   348,
      -1,   349,    -1,   350,    -1,   389,    -1,   390,    -1,   391,
      -1,   392,    -1,   394,    -1,   395,    -1,   396,    -1,   399,
      -1,   400,    -1,   401,    -1,   402,    -1,   403,    -1,   404,
      -1,   405,    -1,   406,    -1,   407,    -1,   410,    -1,   411,
      -1,   412,    -1,   413,    -1,   414,    -1,   415,    -1,   416,
      -1,   417,    -1,   418,    -1,   500,    -1,   501,    -1,   502,
      -1,   503,    -1,   504,    -1,   505,    -1,   506,    -1,   507,
      -1,   541,    -1,   545,   321,    -1,   546,   321,    -1,   375,
     321,    -1,   470,   321,    -1,   472,   321,    -1,   509,   321,
      -1,   513,   321,    -1,   527,   321,    -1,   536,   321,    -1,
     352,   364,   320,    -1,   545,   365,   318,    -1,   545,   353,
     318,    -1,   545,   356,   318,    -1,   354,   364,   320,    -1,
     546,   365,   318,    -1,   546,   355,   318,    -1,    69,    -1,
      70,    -1,   114,    -1,     5,    -1,   199,    -1,   196,    -1,
     200,    -1,   198,    -1,   197,    -1,   201,    -1,   202,    -1,
     203,    -1,   222,    -1,   223,    -1,   230,    -1,   231,    -1,
     232,    -1,   233,    -1,   311,    -1,   312,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   445,   445,   446,   449,   451,   458,   459,   460,   466,
     470,   479,   480,   481,   482,   483,   484,   490,   491,   498,
     505,   506,   510,   514,   521,   529,   530,   536,   545,   546,
     550,   555,   556,   560,   561,   565,   566,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   584,   585,   594,   595,
     596,   597,   600,   601,   602,   603,   607,   614,   617,   620,
     624,   625,   633,   649,   650,   654,   661,   667,   680,   684,
     697,   710,   716,   717,   718,   729,   731,   733,   737,   738,
     739,   740,   747,   755,   759,   765,   771,   773,   777,   778,
     779,   780,   781,   782,   783,   784,   788,   789,   790,   791,
     795,   803,   804,   812,   820,   821,   822,   826,   827,   831,
     836,   837,   844,   853,   854,   855,   859,   868,   874,   875,
     876,   880,   881,   885,   886,   887,   888,   889,   890,   896,
     897,   898,   902,   903,   907,   908,   914,   915,   918,   920,
     924,   925,   929,   947,   948,   949,   950,   951,   952,   960,
     963,   966,   969,   973,   974,   977,   980,   983,   987,   993,
     999,  1006,  1011,  1016,  1021,  1025,  1029,  1039,  1047,  1051,
    1058,  1059,  1062,  1066,  1068,  1070,  1072,  1074,  1076,  1078,
    1081,  1087,  1088,  1089,  1093,  1094,  1100,  1102,  1104,  1106,
    1108,  1110,  1114,  1118,  1121,  1125,  1126,  1127,  1131,  1132,
    1133,  1141,  1141,  1151,  1155,  1156,  1157,  1158,  1159,  1160,
    1161,  1162,  1163,  1164,  1165,  1185,  1196,  1197,  1204,  1205,
    1212,  1221,  1225,  1229,  1253,  1254,  1258,  1271,  1271,  1287,
    1288,  1291,  1292,  1296,  1299,  1308,  1321,  1322,  1323,  1324,
    1328,  1329,  1330,  1331,  1332,  1336,  1339,  1340,  1341,  1345,
    1348,  1357,  1358,  1359,  1363,  1364,  1365,  1369,  1370,  1374,
    1375,  1379,  1386,  1387,  1388,  1389,  1396,  1397,  1400,  1401,
    1408,  1420,  1421,  1425,  1426,  1430,  1431,  1432,  1433,  1434,
    1438,  1439,  1440,  1444,  1458,  1459,  1460,  1461,  1462,  1463,
    1464,  1465,  1466,  1467,  1468,  1478,  1482,  1505,  1539,  1541,
    1542,  1543,  1544,  1545,  1546,  1547,  1551,  1552,  1553,  1554,
    1555,  1556,  1557,  1558,  1559,  1560,  1561,  1562,  1563,  1564,
    1565,  1566,  1568,  1569,  1570,  1572,  1574,  1576,  1578,  1579,
    1580,  1581,  1582,  1592,  1593,  1594,  1595,  1596,  1597,  1602,
    1625,  1626,  1627,  1628,  1629,  1630,  1634,  1637,  1638,  1639,
    1648,  1655,  1664,  1665,  1669,  1675,  1685,  1694,  1700,  1705,
    1712,  1717,  1723,  1724,  1725,  1733,  1735,  1736,  1737,  1738,
    1744,  1766,  1767,  1768,  1769,  1770,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1820,  1831,  1832,  1836,  1837,  1838,  1839,  1840,  1841,
    1844,  1855,  1858,  1860,  1864,  1865,  1866,  1867,  1868,  1869,
    1873,  1874,  1878,  1886,  1888,  1892,  1893,  1894,  1898,  1899,
    1902,  1904,  1907,  1908,  1909,  1910,  1911,  1912,  1913,  1914,
    1915,  1916,  1917,  1920,  1942,  1943,  1944,  1945,  1946,  1947,
    1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,
    1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,
    1968,  1969,  1970,  1973,  1975,  1979,  1980,  1982,  1991,  2001,
    2003,  2007,  2008,  2010,  2019,  2030,  2050,  2052,  2055,  2057,
    2061,  2065,  2066,  2070,  2073,  2076,  2081,  2084,  2089,  2092,
    2095,  2101,  2109,  2110,  2111,  2116,  2117,  2123,  2131,  2132,
    2133,  2136,  2138,  2142,  2146,  2160,  2161,  2162,  2163,  2164,
    2165,  2166,  2167,  2168,  2169,  2170,  2174,  2192,  2194,  2197,
    2199,  2203,  2206,  2219,  2220,  2221,  2222,  2223,  2227,  2232,
    2234,  2237,  2239,  2243,  2249,  2256,  2257,  2258,  2259,  2260,
    2261,  2262,  2263,  2264,  2265,  2266,  2267,  2268,  2272,  2273,
    2274,  2279,  2280,  2281,  2282,  2283,  2286,  2287,  2288,  2291,
    2293,  2296,  2298,  2302,  2311,  2318,  2325,  2326,  2327,  2328,
    2331,  2340,  2347,  2354,  2355,  2359,  2363,  2369,  2372,  2373,
    2374,  2377,  2384,  2384,  2384,  2384,  2384,  2384,  2384,  2384,
    2384,  2384,  2384,  2384,  2384,  2385,  2385,  2385,  2385,  2385,
    2385,  2385,  2385,  2385,  2385,  2385,  2385,  2385,  2385,  2385,
    2385,  2385,  2385,  2385,  2385,  2385,  2385,  2385,  2385,  2385,
    2385,  2385,  2385,  2385,  2385,  2385,  2385,  2385,  2385,  2385,
    2385,  2385,  2386,  2386,  2386,  2386,  2386,  2386,  2386,  2386,
    2386,  2387,  2387,  2387,  2387,  2388,  2388,  2388,  2389,  2389,
    2389,  2390,  2390,  2391,  2392,  2393,  2394,  2395,  2396,  2397,
    2398,  2399,  2400,  2400,  2400,  2400,  2400,  2400
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "LOG", "SYSLOG", "ALL", "DEBUG", "TRACE",
  "INFO", "REMOTE", "WARNING", "ERROR", "AUTH", "FATAL", "BUG", "STDERR",
  "SOFT", "TIMEFORMAT", "ISO", "SHORT", "LONG", "BASE", "NAME",
  "CONFIGURE", "DOWN", "KERNEL", "PERSIST", "SCAN", "TIME", "LEARN",
  "DEVICE", "ROUTES", "ASYNC", "TABLE", "KRT_PREFSRC", "KRT_REALM",
  "ROUTER", "ID", "PROTOCOL", "PREFERENCE", "DISABLED", "DIRECT",
  "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE", "STATES", "FILTERS",
  "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS",
  "INTERFACES", "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS",
  "PREEXPORT", "GENERATE", "LISTEN", "BGP", "V6ONLY", "DUAL", "ADDRESS",
  "PORT", "PASSWORDS", "DESCRIPTION", "RELOAD", "IN", "OUT", "MRTDUMP",
  "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC", "SHOW", "STATUS",
  "SUMMARY", "ROUTE", "SYMBOLS", "DUMP", "RESOURCES", "SOCKETS",
  "NEIGHBORS", "ATTRIBUTES", "ECHO", "DISABLE", "ENABLE", "RESTART",
  "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT", "REJECT",
  "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR", "QUAD", "SET",
  "STRING", "BGPMASK", "BGPPATH", "CLIST", "IF", "THEN", "ELSE", "CASE",
  "TRUE", "FALSE", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE", "CAST",
  "DEST", "LEN", "DEFINED", "ADD", "DELETE", "CONTAINS", "RESET",
  "PREPEND", "FIRST", "LAST", "MATCH", "EMPTY", "WHERE", "EVAL", "LOCAL",
  "NEIGHBOR", "AS", "HOLD", "CONNECT", "RETRY", "KEEPALIVE", "MULTIHOP",
  "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT", "PATH", "METRIC",
  "START", "DELAY", "FORGET", "WAIT", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY", "RR", "RS",
  "CLIENT", "CLUSTER", "AS4", "ADVERTISE", "IPV4", "CAPABILITIES", "LIMIT",
  "PREFER", "OLDER", "MISSING", "LLADDR", "DROP", "IGNORE", "REFRESH",
  "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID", "BGP_CLUSTER_LIST",
  "IGP", "GATEWAY", "RECURSIVE", "MED", "OSPF", "AREA", "OSPF_METRIC1",
  "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB",
  "TICK", "COST", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY", "DEAD",
  "TYPE", "BROADCAST", "BCAST", "NONBROADCAST", "NBMA", "POINTOPOINT",
  "PTP", "POINTOMULTIPOINT", "PTMP", "SIMPLE", "AUTHENTICATION", "STRICT",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "CHECK", "LINK", "RX", "BUFFER", "LARGE", "NORMAL", "STUBNET", "LSADB",
  "ECMP", "WEIGHT", "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE",
  "TRANSPARENT", "RADV", "MIN", "MAX", "RA", "INTERVAL", "MANAGED",
  "OTHER", "CONFIG", "MTU", "REACHABLE", "RETRANS", "TIMER", "CURRENT",
  "VALID", "PREFERRED", "LIFETIME", "SKIP", "ONLINK", "AUTONOMOUS", "RIP",
  "INFINITY", "PERIOD", "GARBAGE", "TIMEOUT", "MULTICAST", "QUIET",
  "NOLISTEN", "VERSION1", "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS",
  "RIP_METRIC", "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH", "'('", "')'",
  "';'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'", "$accept",
  "config", "conf_entries", "expr", "definition", "bool", "ipa", "prefix",
  "prefix_or_ipa", "pxlen", "datetime", "text_or_none", "log_config",
  "syslog_name", "log_file", "log_mask", "log_mask_list", "log_cat",
  "mrtdump_base", "timeformat_which", "timeformat_spec", "timeformat_base",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_DOWN", "cfg_name",
  "kern_proto_start", "kern_item", "kif_proto_start", "kif_item",
  "nl_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "newtab", "proto_start", "proto_name", "proto_item", "imexport",
  "rtable", "debug_default", "iface_patt_node_init",
  "iface_patt_node_body", "iface_negate", "iface_patt_node",
  "iface_patt_list", "dev_proto_start", "dev_proto", "dev_iface_init",
  "dev_iface_patt", "debug_mask", "debug_list", "debug_flag",
  "mrtdump_mask", "mrtdump_list", "mrtdump_flag", "password_list",
  "password_items", "password_item", "password_item_begin",
  "password_item_params", "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY",
  "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL", "optsym",
  "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE",
  "r_args", "export_or_preexport", "cmd_SHOW_SYMBOLS",
  "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES",
  "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES",
  "cmd_DUMP_PROTOCOLS", "cmd_ECHO", "echo_mask", "echo_size",
  "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD",
  "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP",
  "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def", "$@1",
  "filter_eval", "type", "one_decl", "decls", "declsn", "filter_body",
  "filter", "where_filter", "function_params", "function_body",
  "function_def", "$@2", "cmds", "cmds_int", "block", "fipa", "set_atom",
  "switch_atom", "pair_expr", "pair_atom", "pair_item", "set_item",
  "switch_item", "set_items", "switch_items", "fprefix_s", "fprefix",
  "fprefix_set", "switch_body", "bgp_path_expr", "bgp_path",
  "bgp_path_tail1", "bgp_path_tail2", "dpair", "constant", "rtadot",
  "function_call", "symbol", "static_attr", "term", "break_command",
  "print_one", "print_list", "var_listn", "var_list", "cmd",
  "bgp_proto_start", "bgp_proto", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_el", "pref_hid",
  "ipa_list", "ipa_item", "ipa_el", "ipa_ne", "ospf_iface_start",
  "ospf_iface_opts", "ospf_iface_opt_list", "ospf_iface", "opttext",
  "cmd_SHOW_OSPF", "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "pipe_proto_start", "pipe_proto", "radv_proto_start", "radv_proto_item",
  "radv_proto_opts", "radv_proto", "radv_iface_start", "radv_iface_item",
  "radv_iface_finish", "radv_iface_opts", "radv_iface_opt_list",
  "radv_iface", "radv_prefix_start", "radv_prefix_item",
  "radv_prefix_finish", "radv_prefix_opts", "radv_prefix_opt_list",
  "radv_prefix", "rip_cfg_start", "rip_cfg", "rip_auth", "rip_mode",
  "rip_iface_item", "rip_iface_opts", "rip_iface_opt_list",
  "rip_iface_init", "rip_iface", "static_proto_start", "static_proto",
  "stat_route0", "stat_multipath1", "stat_multipath", "stat_route",
  "cmd_SHOW_STATIC", "conf", "cli_cmd", "proto", "kern_proto", "kif_proto",
  "dynamic_attr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,    40,    41,    59,    58,
     123,   125,    44,    63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   326,   327,   327,   328,   328,   329,   329,   329,   330,
     330,   331,   331,   331,   331,   331,   331,   332,   332,   333,
     334,   334,   335,   335,   336,   337,   337,   338,   339,   339,
     340,   340,   340,   341,   341,   342,   342,   343,   343,   343,
     343,   343,   343,   343,   343,   343,   344,   344,   345,   345,
     345,   345,   346,   346,   346,   346,   347,   348,   349,   350,
     351,   351,   352,   353,   353,   353,   353,   354,   355,   355,
     356,   357,   358,   358,   358,   359,   360,   360,   361,   361,
     361,   361,   362,   363,   364,   364,   365,   365,   365,   365,
     365,   365,   365,   365,   365,   365,   366,   366,   366,   366,
     367,   368,   368,   369,   370,   370,   370,   371,   371,   372,
     373,   373,   374,   375,   375,   375,   376,   377,   378,   378,
     378,   379,   379,   380,   380,   380,   380,   380,   380,   381,
     381,   381,   382,   382,   383,   383,   384,   384,   385,   385,
     386,   386,   387,   388,   388,   388,   388,   388,   388,   389,
     390,   391,   392,   393,   393,   394,   395,   396,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     398,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   408,   408,   409,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   419,   419,   420,   420,
     420,   422,   421,   423,   424,   424,   424,   424,   424,   424,
     424,   424,   424,   424,   424,   425,   426,   426,   427,   427,
     428,   429,   429,   430,   431,   431,   432,   434,   433,   435,
     435,   436,   436,   437,   437,   438,   439,   439,   439,   439,
     440,   440,   440,   440,   440,   441,   442,   442,   442,   443,
     443,   444,   444,   444,   445,   445,   445,   446,   446,   447,
     447,   448,   449,   449,   449,   449,   450,   450,   451,   451,
     451,   452,   452,   453,   453,   454,   454,   454,   454,   454,
     455,   455,   455,   456,   457,   457,   457,   457,   457,   457,
     457,   457,   457,   457,   457,   458,   459,   460,   461,   461,
     461,   461,   461,   461,   461,   461,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     463,   463,   463,   463,   463,   463,   464,   465,   465,   465,
     466,   466,   467,   467,   468,   468,   468,   468,   468,   468,
     468,   468,   468,   468,   468,   468,   468,   468,   468,   468,
     469,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   471,   472,   472,   473,   473,   473,   473,   473,   473,
     474,   475,   476,   476,   477,   477,   477,   477,   477,   477,
     478,   478,   479,   480,   480,   481,   481,   481,   482,   482,
     483,   483,   484,   484,   484,   484,   484,   484,   484,   484,
     484,   484,   484,   485,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   487,   487,   488,   488,   489,   490,   491,
     491,   492,   492,   493,   494,   495,   496,   496,   497,   497,
     498,   499,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   509,   509,   509,   509,   510,   511,   511,
     511,   512,   512,   513,   514,   515,   515,   515,   515,   515,
     515,   515,   515,   515,   515,   515,   516,   517,   517,   518,
     518,   519,   520,   521,   521,   521,   521,   521,   522,   523,
     523,   524,   524,   525,   526,   527,   527,   527,   527,   527,
     527,   527,   527,   527,   527,   527,   527,   527,   528,   528,
     528,   529,   529,   529,   529,   529,   530,   530,   530,   531,
     531,   532,   532,   533,   534,   535,   536,   536,   536,   536,
     537,   538,   538,   539,   539,   540,   540,   540,   540,   540,
     540,   541,   542,   542,   542,   542,   542,   542,   542,   542,
     542,   542,   542,   542,   542,   543,   543,   543,   543,   543,
     543,   543,   543,   543,   543,   543,   543,   543,   543,   543,
     543,   543,   543,   543,   543,   543,   543,   543,   543,   543,
     543,   543,   543,   543,   543,   543,   543,   543,   543,   543,
     543,   543,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   545,   545,   545,   545,   546,   546,   546,   547,   547,
     547,   547,   547,   547,   547,   547,   547,   547,   547,   547,
     547,   547,   547,   547,   547,   547,   547,   547
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     1,     3,     1,     5,
       5,     1,     1,     1,     1,     1,     0,     1,     1,     2,
       1,     1,     2,     2,     1,     1,     0,     4,     2,     0,
       1,     2,     1,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     3,     1,     1,
       1,     1,     2,     4,     3,     3,     3,     3,     4,     2,
       0,     1,     2,     2,     3,     2,     3,     2,     3,     3,
       3,     4,     1,     1,     1,     4,     0,     2,     2,     2,
       1,     1,     2,     1,     0,     1,     0,     2,     2,     2,
       2,     2,     2,     2,     3,     2,     2,     1,     1,     1,
       1,     3,     3,     0,     1,     1,     2,     0,     1,     3,
       1,     3,     2,     3,     3,     3,     0,     3,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     3,     1,     1,     4,     1,     0,     3,
       4,     1,     2,     0,     5,     5,     5,     5,     4,     3,
       3,     4,     5,     1,     0,     3,     4,     4,     0,     2,
       3,     3,     3,     2,     2,     2,     3,     3,     2,     2,
       1,     1,     4,     3,     3,     3,     3,     3,     3,     3,
       4,     1,     1,     1,     0,     1,     3,     3,     3,     3,
       4,     4,     4,     4,     2,     1,     1,     1,     1,     0,
       1,     0,     4,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     0,     3,     1,     3,
       1,     1,     1,     2,     3,     2,     4,     0,     5,     0,
       1,     1,     2,     1,     3,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     1,     1,     1,     3,     1,     5,
      11,     1,     1,     3,     1,     1,     3,     1,     3,     1,
       3,     3,     1,     2,     2,     6,     1,     3,     0,     4,
       3,     1,     3,     3,     3,     2,     2,     2,     2,     0,
       2,     2,     0,     5,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     1,     1,     0,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     4,     1,     1,     1,     1,     2,     2,     3,     3,
       6,     3,     3,     3,     3,     6,     6,     6,     6,     4,
       1,     1,     1,     1,     1,     1,     1,     0,     1,     3,
       1,     3,     0,     1,     4,     6,     4,     3,     5,     5,
       4,     6,     3,     2,     5,     5,     8,     8,     8,     8,
       2,     3,     3,     5,     6,     6,     6,     4,     4,     5,
       6,     6,     5,     3,     4,     5,     5,     5,     5,     4,
       4,     5,     5,     5,     5,     5,     5,     5,     6,     6,
       8,     6,     6,     5,     4,     5,     4,     5,     4,     5,
       5,     2,     3,     3,     1,     2,     2,     4,     2,     1,
       2,     4,     0,     3,     3,     2,     4,     2,     2,     1,
       4,     1,     1,     0,     3,     2,     2,     2,     4,     1,
       0,     3,     0,     2,     2,     3,     2,     2,     3,     2,
       2,     2,     1,     3,     2,     2,     2,     2,     2,     2,
       3,     2,     2,     2,     2,     2,     2,     2,     2,     3,
       2,     3,     2,     3,     3,     4,     2,     2,     2,     3,
       3,     3,     1,     0,     2,     1,     1,     2,     3,     0,
       2,     1,     1,     2,     3,     0,     0,     3,     0,     3,
       3,     1,     0,     4,     6,     6,     6,     7,     6,     7,
       6,     2,     3,     3,     5,     4,     4,     2,     1,     2,
       2,     0,     3,     4,     0,     4,     4,     3,     2,     3,
       3,     3,     3,     4,     3,     2,     0,     0,     3,     0,
       3,     4,     1,     2,     2,     2,     3,     3,     0,     0,
       3,     0,     3,     3,     2,     3,     3,     4,     4,     4,
       5,     5,     4,     3,     4,     4,     4,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     2,     2,     0,
       3,     0,     3,     0,     3,     2,     3,     3,     5,     3,
       2,     2,     3,     1,     2,     3,     3,     3,     2,     2,
       2,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    60,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,     3,     1,     2,     0,     0,     0,     0,
       0,     0,    83,     0,     0,     0,     0,   295,   602,   603,
     604,   605,   606,    84,    84,   607,   608,   609,     0,   611,
      84,    86,   612,   613,   614,    84,    86,    84,    86,    84,
      86,    84,     0,    84,    86,    84,    86,     5,   610,    86,
      86,   195,   197,   196,     0,    61,    60,     0,    59,     0,
       0,     0,     0,   194,   199,     0,     0,     0,   158,   154,
     154,   154,     0,     0,     0,     0,     0,     0,     0,   183,
     182,   181,   184,     0,     0,     0,     0,    30,    29,    32,
       0,     0,     0,    51,    50,    49,    48,     0,     0,    82,
       0,   201,    76,     0,     0,   227,   279,   284,   293,   290,
     235,   297,   287,     0,     0,   282,   295,   325,     0,   285,
     286,     0,     0,     0,     0,   295,     0,   288,   289,   294,
     324,   323,     0,   322,   203,    85,     0,     0,    62,    67,
     112,   370,   411,   511,   517,   554,   585,     0,     0,     0,
       0,     0,    16,   116,     0,     0,     0,     0,   654,     0,
       0,     0,     0,     0,    16,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,     0,     0,     0,     0,     0,     0,
     655,     0,     0,     0,    16,     0,    16,   656,   414,     0,
       0,   419,     0,     0,     0,   657,     0,     0,   658,     0,
     583,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     659,     0,     0,   137,   141,     0,     0,     0,   660,     0,
       0,     0,     0,    16,     0,    16,     0,   652,     0,     0,
       0,     0,    26,   653,     0,     0,   119,   118,     0,     0,
       0,    57,     0,     0,   189,   130,   129,     0,     0,   198,
     200,   199,     0,   155,     0,   150,   149,     0,   153,     0,
     154,   154,   154,   154,   154,     0,     0,   178,   179,   175,
     173,   174,   176,   177,   185,     0,   186,   187,   188,     0,
       0,    31,    33,     0,     0,   101,     6,     8,   295,   102,
      52,     0,    56,    72,    73,    74,     0,   216,     0,    47,
       0,     0,   279,   297,   279,   295,   279,   279,     0,   271,
       0,   295,     0,     0,   282,   282,     0,   320,   295,   295,
     295,   295,   295,     0,   239,   237,   295,   236,   238,   252,
     251,   257,     0,   262,   266,     0,   671,   668,   669,   298,
     670,   299,   300,   301,   302,   303,   304,   305,   673,   676,
     675,   672,   674,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   326,   327,   295,   295,   295,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,     0,
     661,   665,   113,    89,   100,    93,     0,    87,    12,    14,
      13,    15,    11,    88,   103,    98,   216,    99,   295,    91,
      97,    92,    95,    90,   114,   115,   371,     0,     0,     0,
       0,     0,     0,     0,    16,     0,    17,    18,     0,     0,
       0,     0,     0,     0,   383,     0,     0,     0,     0,     0,
      16,     0,     0,     0,     0,    16,     0,    16,     0,    16,
       0,    16,     0,     0,    16,   372,   412,   420,   415,   418,
     416,   413,   422,   512,     0,     0,     0,   513,   521,   555,
     103,     0,   142,     0,   138,   570,   568,   569,     0,     0,
       0,     0,     0,     0,     0,     0,   556,   563,   143,   586,
       0,   590,    16,   587,   599,     0,   598,   600,     0,   589,
       0,    63,     0,    65,    16,   663,   664,   662,     0,    25,
       0,   667,   666,   124,   123,   125,   127,   128,   126,     0,
     121,   192,    58,   190,   191,   134,   135,     0,   132,   193,
       0,   151,   156,   157,   164,     0,     0,   171,   216,   165,
     168,   169,     0,   170,   159,     0,   163,   172,   502,   502,
     502,   154,   502,   154,   502,   503,   601,   180,     0,     0,
      28,    37,    38,    39,    40,    41,    42,    43,    44,    45,
       0,    35,    27,     0,     0,    54,    55,    71,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,     0,     0,
       0,   202,   220,    80,    81,     0,     0,    75,    77,    46,
       0,   216,   275,   276,     0,   277,   278,   273,   261,   350,
     353,     0,   333,   334,   280,   281,   274,     0,     0,     0,
       0,     0,   306,   295,   248,   246,     0,   245,     0,     0,
     291,   263,   264,     0,     0,   292,   318,   316,   314,   311,
     312,   313,   315,   317,   319,   307,   308,   309,   310,   328,
       0,   329,   331,   332,    94,   107,   110,   117,   221,   222,
      96,   223,     0,     0,   406,   408,     0,    16,    16,     0,
       0,     0,     0,     0,     0,     0,     0,   384,     0,     0,
       0,     0,     0,     0,   377,     0,   378,     0,   404,     0,
       0,     0,     0,     0,     0,     0,   389,   390,     0,     0,
       0,     0,   515,   516,    86,   581,   567,   558,     0,     0,
     562,   557,   559,     0,     0,   565,   566,   564,     0,     0,
       0,     0,     0,     0,    19,     0,   596,   595,     0,   593,
     597,    70,    64,    66,    68,    21,    20,    69,   120,     0,
     131,     0,   152,   161,   167,   162,   160,   166,   501,     0,
       0,     0,   502,     0,   502,     0,    10,     9,    34,     0,
       7,    53,   215,   214,   216,   295,    78,    79,   225,   218,
       0,   228,   272,   295,   339,   295,   321,   295,   295,   295,
       0,   295,   295,   235,   253,   258,     0,     0,   267,   295,
     108,     0,   103,     0,     0,   407,     0,     0,   403,   397,
     373,     0,     0,   379,     0,   382,     0,   385,   396,   395,
     391,     0,     0,   405,   394,   386,   387,   388,   409,   410,
     393,   392,   417,   495,    16,     0,     0,     0,   421,     0,
     429,   439,   514,   524,     0,   518,     0,   579,   584,   136,
     138,   560,   561,     0,     0,     0,     0,     0,   140,    22,
      23,   588,   591,     0,   594,   122,   133,   505,   504,   510,
       0,   506,     0,   508,    36,   217,     0,   343,     0,   344,
     345,     0,   295,   341,   342,   340,   295,   295,     0,   295,
       0,     0,   295,   231,   224,     0,   351,     0,     0,     0,
       0,   283,   247,   245,     0,     0,     0,   104,   105,   109,
     111,   399,     0,   401,   402,   374,   375,   381,   380,   398,
     376,   103,   428,     0,   425,   483,     0,   432,   427,   431,
     423,   440,   103,   520,   542,   551,   519,   522,   576,   139,
     143,    24,     0,     0,     0,     0,   592,   507,   509,   295,
     295,   295,   295,     0,     0,     0,   226,   232,     0,     0,
     363,   346,   348,     0,   219,   338,   336,   337,   335,   249,
       0,   330,   106,     0,   498,   424,     0,   453,   433,   442,
     539,   549,   548,     0,     0,   582,     0,   148,   143,   143,
     143,   143,     0,     0,     0,     0,   357,   295,   268,   295,
     295,     0,   295,   362,     0,   265,   400,   496,   500,   426,
       0,   484,   485,   486,     0,     0,     0,     0,     0,     0,
       0,   438,   452,     0,   537,   536,     0,   553,   577,   571,
     572,   573,   574,   575,   578,   580,   144,   145,   146,   147,
     356,   296,   360,     0,   295,   354,   233,     0,     0,     0,
       0,     0,     0,     0,     0,   349,   295,     0,     0,   487,
      16,     0,    16,   430,     0,   446,   444,   443,     0,     0,
     447,   449,   450,   451,   441,     0,   541,     0,     0,    16,
      16,    16,   552,     0,     0,     0,   295,   295,   240,   244,
     242,   295,   364,   243,   255,   254,   259,     0,   359,   358,
     295,   295,   295,   295,   365,     0,     0,     0,    16,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   499,   482,     0,   488,   436,   437,   435,   434,
     445,   448,     0,     0,     0,     0,     0,    16,     0,     0,
       0,     0,   540,     0,     0,     0,   543,   544,   545,   550,
     361,   234,   355,   270,   245,     0,   295,     0,     0,     0,
       0,     0,   295,   489,   458,   472,   454,   457,   455,     0,
     470,     0,   459,   461,   462,   463,   464,   465,   466,   467,
     468,   476,   477,   478,    16,   456,    16,     0,     0,   497,
     535,     0,     0,     0,     0,     0,   528,    16,     0,     0,
       0,   538,   546,   547,   241,   295,   256,   269,   260,     0,
       0,     0,     0,     0,     0,   469,   460,   471,   473,   479,
     480,   481,   474,   534,   530,   527,     0,     0,   529,   531,
     532,     0,     0,   369,   367,   368,   366,   250,     0,   475,
     490,   491,   492,   525,   526,   533,     0,   493,   494
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,   452,    69,   453,   540,   786,   787,   774,
     982,   560,    70,   341,   140,   344,   620,   621,    71,   147,
     148,    72,    16,    17,    18,   107,    73,   288,    74,   294,
     289,    75,   356,    76,   358,   648,    77,    78,   186,   209,
     459,   445,    79,   705,   949,   841,   706,   707,    80,    81,
     454,   210,   299,   569,   570,   308,   577,   578,   272,   758,
     273,   274,   771,    19,    20,    21,    22,   319,    23,    24,
      25,   317,   595,    26,    27,    28,    29,    30,    31,    32,
      33,    34,   132,   335,    35,    36,    37,    38,    39,    40,
      41,    42,    43,   104,   312,    82,   357,    83,   638,   639,
     640,   820,   709,   710,   460,   651,   642,    84,   361,   928,
     929,  1085,   177,   389,  1134,   675,   676,   390,   391,  1136,
     392,  1137,   178,   394,   395,  1087,   367,   179,   368,   376,
     180,   181,   182,   931,   183,   424,   943,   932,  1002,  1003,
     660,   661,   933,    85,    86,    87,    88,   249,   250,   251,
     750,   879,   968,   969,  1054,  1104,   880,  1019,  1063,   881,
    1164,  1016,  1051,  1052,  1053,  1254,  1280,  1281,  1282,   961,
    1097,  1048,   962,   799,    44,    45,    46,    47,    48,    49,
      50,    51,    89,    90,    91,   886,   754,    92,   972,  1183,
    1116,  1115,  1065,   973,   975,  1123,  1067,  1066,  1022,   976,
      93,    94,   528,  1074,  1026,   978,   888,   520,   521,    95,
      96,   280,   779,   780,   281,    52,    97,    53,    98,    99,
     100,   425
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1029
static const yytype_int16 yypact[] =
{
      64,  1781,   116,    23,   246,   122,   102,   269,   246,   118,
     463,   805,   374,   246,   246,   246, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029,   120,   513,    71,   399,
     245,   142, -1029,   284,   143,    40,   354,   792, -1029, -1029,
   -1029, -1029, -1029,   397,   397, -1029, -1029, -1029,   608, -1029,
     397,  1722, -1029, -1029, -1029,   397,  1556,   397,  1602,   397,
     383,   397,   -48,   397,  1581,   397,  1497, -1029, -1029,  1495,
    1678, -1029, -1029, -1029,    55, -1029,   410,   453, -1029,   246,
     246,   466,    79, -1029,   412,    70,   470,   487, -1029,   482,
     393,   482,   512,   577,   585,   604,   640,   652,   660, -1029,
   -1029, -1029,   421,   672,   684,   690,   563, -1029,   558, -1029,
     -12,    55,    38, -1029, -1029, -1029, -1029,    98,   385, -1029,
     560, -1029, -1029,   406,    79, -1029,    35, -1029, -1029, -1029,
     697,   413, -1029,   561,   564,     7,   792, -1029,   422, -1029,
   -1029,   437,   438,   439,   443,   792,   119, -1029, -1029, -1029,
   -1029, -1029,  1388, -1029,  1979, -1029,   429,   432, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029,   448,    55,   744,
     698,    38,   369, -1029,   394,   394,   749,    79, -1029,   471,
     473,   468,   123,   753,   369,   580,   598,   -38,   699,   110,
     478,   740,   626,   751,     8,   639,   634,   308,   635,   637,
     195,   624,   623,   369,   618,   619,   627,   -16,   -28,   644,
   -1029,   525,   529,   560,   369,    38,   369, -1029, -1029,   532,
     531, -1029,   534,   784,   254, -1029,   538,   537, -1029,   541,
   -1029,   838,    38,   542,   -52,    38,    38,   800,   801,  -102,
   -1029,   550,   551, -1029,   547,   559,   478,   616, -1029,   552,
     452,   562,   814,   369,   820,   369,   837, -1029,   586,   591,
     593,   850,   894, -1029,   597,   601, -1029, -1029,   819,   922,
     927, -1029,   928,   930, -1029, -1029, -1029,   -24,   932, -1029,
   -1029,   573,   933, -1029,   934, -1029, -1029,  1824, -1029,   936,
     482,   482,   482,   204,   316,   937,   938, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029,   939, -1029, -1029, -1029,    74,
     923, -1029, -1029,   987,   629, -1029, -1029, -1029,   792, -1029,
      38,   549, -1029, -1029, -1029, -1029,   630,  1707,   433, -1029,
     631,   638,    35, -1029,    35,   792,    35,    35,   944, -1029,
     935,   582,   941,   949,     7,     7,   942,   929,   792,   792,
     792,   792,   792,   154, -1029, -1029,   622, -1029, -1029,   952,
   -1029, -1029,   -15,    -2, -1029,   128, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029,   792,   792,   792,   792,
     792,   792,   792,   792,   792,   792,   792,   792,   792,   609,
   -1029, -1029, -1029, -1029, -1029, -1029,   560, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029,  1386, -1029,   792, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029,   900,   901,   647,
     650,    38,   931,   755,   369,   478, -1029, -1029,    38,   811,
     812,    38,   915,    38, -1029,   673,   950,   803,    38,    38,
     369,   953,   674,   946,   676,   369,   677,   369,    44,   369,
     744,   369,   686,   687,   369, -1029, -1029, -1029, -1029, -1029,
     845, -1029, -1029, -1029,  1040,   742,   743, -1029, -1029, -1029,
   -1029,   745, -1029,   747,   978, -1029, -1029, -1029,   748,   750,
     766,    38,    38,   767,   768,   769, -1029, -1029,   274, -1029,
       4, -1029,   369, -1029, -1029,   599, -1029, -1029,   883, -1029,
      38, -1029,    38, -1029,   369, -1029, -1029, -1029,    38, -1029,
     478, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,   303,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029,   338, -1029, -1029,
    1068, -1029, -1029, -1029, -1029,  1072,  1078, -1029,  1386, -1029,
   -1029, -1029,   478, -1029, -1029,  1082, -1029, -1029,  1083,  1083,
    1083,   482,  1083,   482,  1083, -1029, -1029, -1029,   786,   787,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
     345, -1029, -1029,  1111,  1086, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,    28,   794,
     790, -1029, -1029, -1029, -1029,   478,    38, -1029, -1029, -1029,
     700,  1707, -1029, -1029,  1136, -1029, -1029, -1029, -1029,   224,
   -1029,   797, -1029, -1029, -1029, -1029, -1029,   268,  1162,   417,
     455,   500, -1029,   792, -1029,  1117,   796,  1111,   222,   379,
   -1029, -1029, -1029,  1110,  1108, -1029,  2004,  2004,  2004,  2029,
    2029,  2004,  2004,  2004,  2004,   519,   519,   929,   929, -1029,
     813, -1029, -1029, -1029, -1029,  1103, -1029,   809, -1029, -1029,
   -1029,  1979,    38,    38, -1029, -1029,   823,   369,   369,   824,
     831,   832,    38,    38,   833,    38,   834, -1029,    38,   835,
     836,   839,   848,    38, -1029,   560, -1029,   849, -1029,   851,
     857,   858,   859,   861,   862,   863, -1029, -1029,   864,    38,
     356,   874, -1029, -1029,  1649,   166, -1029, -1029,   872,   882,
   -1029, -1029, -1029,   884,   885, -1029, -1029, -1029,    38,   270,
     483,   880,    38,   478, -1029,   886, -1029, -1029,   478,   948,
     883, -1029, -1029, -1029, -1029,     4, -1029, -1029, -1029,   819,
   -1029,   -24, -1029, -1029, -1029, -1029, -1029, -1029, -1029,  1152,
    1153,  1202,  1083,  1203,  1083,  1204, -1029, -1029, -1029,   987,
   -1029, -1029, -1029, -1029,  1707,    58, -1029, -1029, -1029, -1029,
     402, -1029, -1029,   792, -1029,   792, -1029,   792,   792,   792,
    1187,   792,   622, -1029, -1029, -1029,   895,   697, -1029,   792,
   -1029,   612, -1029,   890,   903, -1029,   908,   909, -1029, -1029,
   -1029,   910,   911, -1029,   912, -1029,   913, -1029, -1029, -1029,
   -1029,   914,   924, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029,   248,   955,   971,   478, -1029,   925,
   -1029,   956, -1029, -1029,   478, -1029,   940, -1029, -1029, -1029,
     978, -1029, -1029,   959,  1230,  1230,  1230,  1230, -1029, -1029,
   -1029, -1029, -1029,    38,   948, -1029, -1029, -1029, -1029, -1029,
    1248, -1029,  1249, -1029, -1029, -1029,    27, -1029,  1231, -1029,
   -1029,   962,   792, -1029, -1029, -1029,   792,   792,   958,    24,
    1388,   963,   663, -1029, -1029,  1707, -1029,  1212,  1237,  1262,
    1287, -1029, -1029,  1979,   951,  1239,  1312,   478, -1029, -1029,
   -1029, -1029,    38, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029,    38, -1029, -1029,   560, -1029, -1029,   960,
   -1029, -1029, -1029, -1029, -1029,   980, -1029, -1029,   193, -1029,
     274, -1029,   964,   965,   983,   984, -1029, -1029, -1029,   792,
     582,   792, -1029,   689,  1951,   533, -1029, -1029,  1233,   163,
   -1029,  1979,   981,   986, -1029, -1029, -1029, -1029, -1029,  1250,
     985, -1029, -1029,   989,   332, -1029,    13, -1029, -1029,  1456,
     366, -1029, -1029,    38,   216, -1029,   990, -1029,   274,   274,
     274,   274,   772,   988,   865,  1288, -1029,   947, -1029,   792,
     792,   327,   663, -1029,  1001, -1029, -1029, -1029, -1029, -1029,
    -134, -1029, -1029, -1029,  -106,    38,    38,    38,  1064,   105,
       5, -1029, -1029,  1000, -1029, -1029,   436, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029,  1008,    58,  1176, -1029,    66,   974,  1015,
    1011,  1013,  1014,  1016,  1024, -1029,   792,  1689,  1025, -1029,
     369,    38,   369, -1029,  1032, -1029, -1029, -1029,    38,    38,
   -1029, -1029, -1029, -1029, -1029,  1188, -1029,  1038,  1058,   369,
     369,   369, -1029,  1034,  1035,  1033,   947,    94, -1029, -1029,
   -1029,   622, -1029, -1029,  1348, -1029, -1029,   250, -1029, -1029,
     792,   792,   792,   792, -1029,  1045,  1036,    38,   369,    38,
      38,    38,  1183,    38,   306,   804,    20,  1122,    38,  1115,
    1114,  1109, -1029, -1029,  1062, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029,   478,  1088,  1096,   -85,  1102,   369,  1107,  1338,
    1118,  1214, -1029,  1085,    38,    38, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029,  1337,   131,    94,   186,  1362,  1387,
    1412,  1437,   792, -1029, -1029, -1029, -1029, -1029, -1029,    38,
   -1029,    38, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029,   369, -1029,   369,    36,    38, -1029,
   -1029,    38,    38,    38,  1124,  1126, -1029,   369,    38,    38,
    1192, -1029, -1029, -1029, -1029,   792, -1029, -1029, -1029,  1099,
    1100,  1112,  1113,  1116,    16, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029,    38,    38, -1029, -1029,
   -1029,    38,  1337, -1029, -1029, -1029, -1029, -1029,  -177, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029,  1125, -1029, -1029
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1029, -1029, -1029,  -139, -1029,  -168,  -207,  -272,  -571, -1029,
    -225, -1029, -1029, -1029, -1029, -1029, -1029,   617, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029,  1319, -1029, -1029, -1029, -1029,
   -1029, -1029,  -241, -1029, -1029, -1029, -1029, -1029,  1022,   -80,
    1222,   954, -1029, -1029, -1029, -1029,   587,  -513, -1029, -1029,
   -1029, -1029,   -53, -1029,   643,  -110, -1029,   651,  -875,   565,
    -509, -1029,  -384, -1029, -1029, -1029, -1029,  -103, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029,   613,  1140, -1029, -1029, -1029, -1029,  -615,
     642, -1029,  1095,   889,  1157, -1029,   829, -1029, -1029,  -868,
   -1029,   344,  -175,   815,   286,  -822,   662, -1028,   816,   285,
   -1029, -1029,  -171,   799, -1029, -1029, -1029, -1029,   343,   367,
   -1029, -1029,  -779, -1029,    56,   566,   -67, -1029, -1029,   450,
     675,   507,  -827, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029,  -533, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,   328,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029,   719, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029,  -892
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -524
static const yytype_int16 yytable[] =
{
     184,   388,   507,   349,   541,   393,   241,   755,   248,   942,
     256,  1100,   479,   480,   271,   759,   279,   325,   326,   290,
     295,   796,   374,   346,   681,   682,    55,   347,   342,   525,
    -230,   476,   477,   772,  1278,   819,   930,   387,   999,  -230,
    -230,  -230,  -230,   916,   360,   594,   470,   812,   502,   989,
     362,   346,   500,   346,   363,   347,    56,   347,   575,  1135,
     153,    57,   447,   364,    58,   496,   800,   801,     1,   803,
     917,   805,  1127,   313,   533,    59,   508,   916,   510,  1286,
     473,  1128,  1129,  1130,   833,   485,  1111,   576,   345,   346,
     296,    60,   608,   347,    61,   297,    62,   463,   918,   377,
    -229,  1221,   997,    63,   917,   108,   509,  1233,   383,  -229,
    -229,  -229,  -229,   916,   305,   551,    54,   553,   350,   306,
     346,   113,    64,   523,   347,  1098,   529,   530,   476,   477,
     154,  1101,   918,    65,   346,   384,   385,   160,   347,   136,
     917,  1287,   105,  1083,  1062,   443,  1128,  1129,  1130,   833,
     930,   351,    66,  1102,   919,   920,   921,   922,   923,   924,
     925,   141,   426,   427,   428,   429,   430,   142,   918,  1135,
     474,   813,   926,   106,   501,   927,   431,   432,   433,   434,
     435,   436,   437,   438,  1099,  1040,   439,   314,   919,   920,
     921,   922,   923,   924,   925,  1041,  1234,    67,   503,  1109,
     609,  1128,  1129,  1130,   833,   704,   926,   534,   535,   927,
    1086,   624,   369,  1035,   150,  1103,  1125,   598,   599,   600,
     602,   604,  1163,   318,   919,   920,   921,   922,   923,   924,
     925,   740,   426,   427,   428,   429,   430,   346,   384,   385,
     833,   347,   926,   152,   601,   927,   431,   432,   433,   434,
     435,   436,   437,   438,   526,   527,   439,  1112,   930,  1193,
    1113,   741,   742,   346,   149,   101,   102,   347,   720,   910,
     948,   912,  1222,   258,  1145,  1223,   426,   427,   428,   429,
     430,   623,   448,   449,   450,   451,   103,   478,   101,   102,
     431,   432,   433,   434,   435,   436,   437,   438,   654,  1086,
     439,  1259,  1260,   151,   659,   930,   719,   679,   343,   103,
     680,   667,   668,   669,   670,   671,   467,   468,   683,   677,
    1004,   346,   732,   773,   348,   347,   484,   737,  1247,   739,
     375,   743,   716,   745,  1049,   318,   748,  1279,   777,   721,
    -230,    68,   724,   990,   726,  -230,   768,   930,   930,   730,
     731,   365,   348,   785,   348,   894,   603,   895,   366,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   769,   155,   775,   298,  1012,   109,   110,  -229,
    1253,   759,  1131,  1023,   346,   785,   783,  1132,   347,   129,
     348,   711,   763,   764,   346,   384,   385,   833,   347,   307,
    1211,   492,   493,   448,   449,   450,   451,  1090,   770,   130,
    -229,   781,   318,   782,   131,  -229,   185,   930,   369,   784,
     369,   348,   369,   369,   198,   426,   427,   428,   429,   430,
     105,   309,   310,   873,   455,   386,   334,   143,   816,   431,
     432,   433,   434,   435,   436,   437,   438,  1245,  1014,   439,
     684,   199,   311,   685,   200,   144,   301,   201,   202,  1020,
    1069,   204,   205,   426,   427,   428,   429,   430,  1024,   304,
     320,   672,   145,   315,   456,   457,   673,   431,   432,   433,
     434,   435,   436,   437,   438,   963,   887,   439,   842,   206,
     316,  1091,  1092,   207,   862,  1093,   476,   477,   802,  1094,
     804,   318,  1131,   388,   388,   488,   489,   817,   426,   427,
     428,   429,   430,   393,  1025,   327,   321,   146,  1070,  1071,
    1072,  1073,   431,   432,   433,   434,   435,   436,   437,   438,
     515,   516,   439,   137,   643,   644,   645,   646,   348,   387,
     387,   426,   427,   428,   429,   430,   823,   437,   438,   846,
     847,   439,   138,   114,   115,   431,   432,   433,   434,   435,
     436,   437,   438,   139,   348,   439,   900,   458,   896,  1196,
     897,   902,  1197,   843,   844,   353,   116,   354,   355,   117,
     328,   118,   119,   851,   852,   339,   854,   544,   329,   856,
     825,   874,   309,   310,   861,   156,  1027,   157,   158,   159,
     160,   161,   162,   625,   626,   967,   830,   330,   163,   164,
     872,   165,   974,   166,   875,   340,   876,   476,   477,   776,
     111,   112,   348,   877,   788,   789,   133,   134,   135,   893,
     476,   477,   947,   899,   785,   156,   545,   157,   158,   159,
     160,   161,   162,   331,  1076,  1077,  1078,  1079,   163,   164,
     674,   165,  1047,   166,   842,   332,   167,   253,   254,   790,
     791,   322,   168,   333,   323,   324,   808,   809,   188,   546,
     983,   984,   985,   189,   885,   336,   156,   878,   157,   158,
     159,   160,   161,   162,   190,   348,  1064,   337,   842,   163,
     164,   120,   165,   338,   166,   386,   167,   426,   427,   428,
     429,   430,   168,   352,   255,   652,   964,   653,   191,   655,
     656,   431,   432,   433,   434,   435,   436,   437,   438,   934,
     935,   439,   302,   303,   359,  1017,   370,  1117,  1118,   371,
    1119,  1120,  1121,   372,   169,   170,   373,   167,   378,   827,
     785,   664,   665,   168,  1050,   171,   172,   173,   699,   440,
     174,   647,   441,   379,   380,   381,   659,  1122,   937,   382,
     938,   939,   940,   444,   986,   700,   547,   548,   442,   462,
     446,   701,   946,   469,   169,   170,   121,   828,   702,   703,
     426,   427,   428,   429,   430,   171,   172,   173,   466,   464,
     174,   465,   471,   472,   431,   432,   433,   434,   435,   436,
     437,   438,   475,   481,   439,   156,   482,   157,   158,   159,
     160,   161,   162,  1013,   483,   169,   170,   486,   163,   164,
     487,   165,   829,   166,  1015,   490,   171,   172,   173,   491,
     494,   174,   497,   495,   504,   498,   192,   628,   629,   630,
     631,   632,   633,   505,   634,   635,   636,   637,   499,   506,
     511,   512,   514,  1038,   513,   993,   517,   518,   522,   994,
     995,   519,   524,   531,   532,  1001,   167,   538,   536,   537,
     543,   122,   168,   426,   427,   428,   429,   430,   542,   539,
     549,   193,   550,   552,  1068,   563,   194,   431,   432,   433,
     434,   435,   436,   437,   438,   123,   124,   439,   175,  -352,
     974,   564,   565,   554,   555,   195,   176,   566,   567,   556,
     568,   557,  1133,   558,   559,   561,  1105,  1106,  1107,   562,
    1110,   196,  1032,   659,  1034,   571,   125,   126,   127,   128,
     572,   573,  1166,   574,  1168,   579,   581,   582,   175,   597,
     605,   606,   607,   610,   169,   170,   176,   622,   627,   649,
     658,  1186,  1187,  1188,   650,   171,   172,   173,   657,   678,
     174,   439,  1167,   712,   713,   714,   916,   662,   715,  1170,
    1171,   666,  1088,  1089,   718,  1001,   663,   717,   725,   175,
    1205,  -347,   426,   427,   428,   429,   430,   176,   722,   723,
     729,   727,   734,   917,   736,   738,   431,   432,   433,   434,
     435,   436,   437,   438,   746,   747,   439,  1036,  1204,  1236,
    1206,  1207,  1208,   728,  1210,  1212,   733,   818,   735,  1225,
    1133,   918,  1133,   426,   427,   428,   429,   430,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   431,   432,   433,
     434,   435,   436,   437,   438,  1242,  1243,   439,  1213,  1214,
    1215,  1216,  1217,  1218,  1219,  1220,  1257,   749,  1258,   751,
     752,   753,   261,   756,  1194,   757,   760,   778,   761,  1268,
    1255,   792,  1256,  1198,  1199,  1200,  1201,   919,   920,   921,
     922,   923,   924,   925,   762,   765,   766,   767,  1261,  1262,
    1080,   793,  1263,  1264,  1265,   926,   187,   794,   927,  1269,
    1270,   797,   197,   798,   806,   807,   811,   211,   175,   242,
     815,   252,   814,   257,   824,   259,   176,   275,   832,   426,
     427,   428,   429,   430,   831,   836,   837,  1283,  1284,   839,
     840,   842,  1285,   431,   432,   433,   434,   435,   436,   437,
     438,   845,   848,   439,   426,   427,   428,   429,   430,   849,
     850,   853,   855,   857,   858,   907,   908,   859,   431,   432,
     433,   434,   435,   436,   437,   438,   860,   863,   439,   864,
     426,   427,   428,   429,   430,   865,   866,   867,  1272,   868,
     869,   870,   871,  1082,   431,   432,   433,   434,   435,   436,
     437,   438,   882,   889,   439,   426,   427,   428,   429,   430,
     890,   898,   891,   892,   901,   909,   911,   913,   951,   431,
     432,   433,   434,   435,   436,   437,   438,   945,   903,   439,
     426,   427,   428,   429,   430,   952,   953,   954,   955,   956,
     957,   958,   959,   966,   431,   432,   433,   434,   435,   436,
     437,   438,   960,   970,   439,   426,   427,   428,   429,   430,
     981,   987,   988,   991,  1010,  1039,  1108,  1044,   977,   431,
     432,   433,   434,   435,   436,   437,   438,  1084,  1009,   439,
     426,   427,   428,   429,   430,   965,   971,   980,   992,   996,
    1018,  1000,  1028,  1029,   431,   432,   433,   434,   435,   436,
     437,   438,  1138,   396,   439,   426,   427,   428,   429,   430,
    1021,  1030,  1031,  1042,  1043,  1081,  1045,  1046,  1075,   431,
     432,   433,   434,   435,   436,   437,   438,  1096,  1114,   439,
     426,   427,   428,   429,   430,  1124,  1126,  1140,  1172,  1141,
    1142,  1184,  1143,  1139,   431,   432,   433,   434,   435,   436,
     437,   438,  1144,  1165,   439,   426,   427,   428,   429,   430,
    1169,  1185,  1189,  1190,  1191,  1195,  1203,   397,   398,   431,
     432,   433,   434,   435,   436,   437,   438,  1202,  1224,   439,
     426,   427,   428,   429,   430,  1209,  1173,  1226,  1227,  1228,
    1229,  1231,  1232,  1235,   431,   432,   433,   434,   435,   436,
     437,   438,  1237,   396,   439,   426,   427,   428,   429,   430,
    1240,  1238,   400,  1241,  1271,   708,  1266,  1239,  1267,   431,
     432,   433,   434,   435,   436,   437,   438,  1273,  1274,   439,
     426,   427,   428,   429,   430,   300,   914,   461,   810,   950,
    1275,  1276,   905,  1277,   431,   432,   433,   434,   435,   436,
     437,   438,   906,  1288,   439,   426,   427,   428,   429,   430,
    1174,   580,   641,   822,   744,   979,   915,   397,   398,   431,
     432,   433,   434,   435,   436,   437,   438,  1175,  1176,   439,
    1192,  1177,  1178,   399,   596,  1179,  1180,   795,  1181,   826,
     821,  1246,  1248,   838,   408,   409,   410,   411,   412,   413,
     414,   415,  1095,   834,   944,   835,   998,  1033,   936,   904,
    1230,     0,   400,     0,   941,     0,     0,     0,     0,  1182,
     416,   417,     0,     0,     0,     0,     0,     0,   418,   419,
     420,   421,     0,   628,   629,   630,   631,   632,   633,  1005,
     634,   635,   636,   637,     0,     0,   198,     0,   198,     0,
     261,     0,   401,   402,     0,   403,   404,   405,   406,   407,
       0,     0,     0,     0,  1006,   282,   283,   284,     0,   285,
     286,   263,     0,   199,     0,   199,   200,     0,   200,   201,
     202,   201,   202,   204,   205,   204,   205,     0,     0,  1007,
       0,     0,     0,     0,   408,   409,   410,   411,   412,   413,
     414,   415,     0,     0,     0,     0,     0,   198,     0,   422,
     423,   206,   212,   206,  1008,   207,     0,   207,     0,     0,
     416,   417,     0,     0,     0,   276,     0,     0,   418,   419,
     420,   421,   198,     0,   199,     0,     0,   200,     0,  1011,
     201,   202,     0,     0,   204,   205,     0,     0,     0,     0,
     213,     0,   214,   198,     0,     0,     0,     0,     0,   199,
    1055,     0,   200,     0,  1244,   201,   202,     0,   260,   204,
     205,     0,   206,     0,     0,   261,   207,     0,     0,     0,
     199,     0,     0,   200,   215,     0,   201,   202,     0,  1249,
     204,   205,   216,   217,     0,   262,   263,   206,     0,     0,
     198,   207,     0,     0,  1056,  1057,  1058,     0,  1059,   422,
     423,     0,     0,     0,  1250,     0,     0,     0,   206,  1060,
       0,     0,   207,     0,   218,     0,     0,   199,     0,   198,
     200,     0,     0,   201,   202,     0,   883,   204,   205,  1251,
       0,   219,   220,     0,   221,   222,     0,   223,   224,   225,
     291,   226,     0,     0,   227,   228,   199,   229,     0,   200,
       0,     0,   201,   202,  1252,   206,   204,   205,   277,   207,
     230,   231,     0,   198,     0,   232,     0,   233,     0,   234,
     292,   235,     0,   261,     0,     0,   236,  1061,     0,     0,
     237,   238,     0,   239,   206,     0,     0,     0,   207,   884,
     199,     0,     0,   200,   263,     0,   201,   202,     0,   203,
     204,   205,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1146,     0,     0,     0,   287,     0,   278,     0,
       0,     0,     4,     0,     0,     0,     0,   583,   206,     0,
       0,   243,   207,     0,   264,     0,   244,     0,   245,     5,
       6,     0,   476,   477,   628,   629,   630,   631,   632,   633,
       0,   634,   635,   636,   637,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   584,     0,     0,     0,     0,     0,
       0,   246,     0,     0,     0,     0,     0,   240,     0,   265,
     266,   267,   268,  1147,     0,     0,     0,     0,     7,   269,
       0,     8,   585,     9,     0,     0,    10,   586,     0,     0,
       0,    11,   270,   587,   588,     0,    12,    13,    14,    15,
       0,     0,     0,     0,     0,     0,   589,   590,   591,   592,
       0,   593,     0,   247,  1148,     0,  1149,  1150,  1151,  1152,
    1153,  1154,  1155,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1156,  1157,     0,     0,  1158,     0,     0,     0,
    1159,     0,  1160,     0,     0,     0,     0,     0,  1161,   426,
     427,   428,   429,   430,     0,     0,     0,     0,     0,     0,
    -523,     0,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,     0,   439,     0,     0,     0,   426,   427,   428,
     429,   430,     0,     0,     0,     0,     0,   458,     0,   293,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
    1162,   439,  -524,  -524,  -524,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  -524,  -524,  -524,  -524,
     435,   436,   437,   438,     0,     0,   439,   426,   427,   428,
       0,     0,     0,   208,     0,     0,     0,     0,     0,     0,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
       0,   439,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1037
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-1029))

#define yytable_value_is_error(yytable_value) \
  ((yytable_value) == (-524))

static const yytype_int16 yycheck[] =
{
      67,   176,   243,   142,   276,   176,    86,   520,    88,   831,
      90,   117,   219,   220,    94,   524,    96,   120,   121,    99,
     100,   592,    15,    15,    26,    27,     3,    19,    40,    81,
       6,    18,    19,    29,    18,   650,   815,   176,   930,    15,
      16,    17,    18,    19,   154,   317,   214,    19,    76,    22,
      15,    15,    68,    15,    19,    19,    33,    19,    82,  1087,
      20,    38,   201,    28,    41,   233,   599,   600,     4,   602,
      46,   604,     6,     3,   176,    52,   244,    19,   246,   256,
     118,    15,    16,    17,    18,   224,    81,   111,   141,    15,
      35,    68,    18,    19,    71,    40,    73,   207,    74,   166,
       6,    81,   929,    80,    46,     3,   245,   192,   175,    15,
      16,    17,    18,    19,    35,   283,     0,   285,    20,    40,
      15,     3,    99,   262,    19,   259,   265,   266,    18,    19,
      90,   237,    74,   110,    15,    16,    17,    18,    19,    19,
      46,   318,    20,  1035,  1019,   198,    15,    16,    17,    18,
     929,    53,   129,   259,   130,   131,   132,   133,   134,   135,
     136,    90,     8,     9,    10,    11,    12,    96,    74,  1197,
     208,   143,   148,    51,   190,   151,    22,    23,    24,    25,
      26,    27,    28,    29,   318,    22,    32,   117,   130,   131,
     132,   133,   134,   135,   136,    32,   281,   174,   226,    94,
     339,    15,    16,    17,    18,   446,   148,   309,   310,   151,
    1037,   350,   156,   992,    72,   321,  1084,   320,   321,   322,
     323,   324,  1097,    19,   130,   131,   132,   133,   134,   135,
     136,   187,     8,     9,    10,    11,    12,    15,    16,    17,
      18,    19,   148,   100,    40,   151,    22,    23,    24,    25,
      26,    27,    28,    29,   306,   307,    32,   252,  1037,  1127,
     255,   217,   218,    15,    19,    19,    20,    19,   475,   802,
     841,   804,   252,   321,  1096,   255,     8,     9,    10,    11,
      12,   348,    34,    35,    36,    37,    40,   177,    19,    20,
      22,    23,    24,    25,    26,    27,    28,    29,   365,  1126,
      32,   265,   266,    19,   371,  1084,   474,   322,   320,    40,
     325,   378,   379,   380,   381,   382,   193,   194,   320,   386,
     935,    15,   490,   319,   316,    19,   318,   495,  1196,   497,
     323,   499,   471,   501,   321,    19,   504,   321,   545,   478,
     316,   318,   481,   316,   483,   321,    72,  1126,  1127,   488,
     489,   316,   316,   560,   316,    85,    40,    87,   323,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,    98,    19,   542,   320,   947,   108,   109,   321,
    1202,   890,   316,   190,    15,   592,   554,   321,    19,    15,
     316,   458,   531,   532,    15,    16,    17,    18,    19,   320,
      94,   206,   207,    34,    35,    36,    37,    80,   134,    35,
     316,   550,    19,   552,    40,   321,    19,  1196,   362,   558,
     364,   316,   366,   367,    41,     8,     9,    10,    11,    12,
      20,    19,    20,    77,    40,   316,    15,    38,   645,    22,
      23,    24,    25,    26,    27,    28,    29,   316,   961,    32,
     322,    68,    40,   325,    71,    56,     3,    74,    75,   972,
     244,    78,    79,     8,     9,    10,    11,    12,   275,     3,
      77,   317,    73,     3,    80,    81,   322,    22,    23,    24,
      25,    26,    27,    28,    29,   237,   320,    32,   322,   106,
       3,   164,   165,   110,   735,   168,    18,    19,   601,   172,
     603,    19,   316,   678,   679,   197,   198,   646,     8,     9,
      10,    11,    12,   684,   321,     3,   123,   118,   302,   303,
     304,   305,    22,    23,    24,    25,    26,    27,    28,    29,
     276,   277,    32,    20,   101,   102,   103,   104,   316,   678,
     679,     8,     9,    10,    11,    12,   322,    28,    29,   717,
     718,    32,    39,    90,    91,    22,    23,    24,    25,    26,
      27,    28,    29,    50,   316,    32,   773,   173,    85,   319,
      87,   778,   322,   712,   713,    15,   113,    17,    18,   116,
       3,   118,   119,   722,   723,    22,   725,   135,     3,   728,
     322,   235,    19,    20,   733,    13,   980,    15,    16,    17,
      18,    19,    20,    54,    55,   877,   673,     3,    26,    27,
     749,    29,   884,    31,   258,    57,   260,    18,    19,    20,
       7,     8,   316,   267,   321,   322,    13,    14,    15,   768,
      18,    19,    20,   772,   841,    13,   184,    15,    16,    17,
      18,    19,    20,     3,  1028,  1029,  1030,  1031,    26,    27,
      28,    29,   320,    31,   322,     3,    74,   274,   275,   321,
     322,   268,    80,     3,   271,   272,   321,   322,    60,   217,
     895,   896,   897,    65,   754,     3,    13,   321,    15,    16,
      17,    18,    19,    20,    76,   316,   320,     3,   322,    26,
      27,   228,    29,     3,    31,   316,    74,     8,     9,    10,
      11,    12,    80,   318,   321,   362,   874,   364,   100,   366,
     367,    22,    23,    24,    25,    26,    27,    28,    29,   317,
     318,    32,   109,   110,   318,   966,    29,   291,   292,   316,
     294,   295,   296,   172,   152,   153,   172,    74,   316,   322,
     947,   374,   375,    80,  1016,   163,   164,   165,   139,   320,
     168,   318,   320,   316,   316,   316,   823,   321,   825,   316,
     827,   828,   829,    19,   903,   156,   314,   315,   320,    20,
      72,   162,   839,    20,   152,   153,   313,   322,   169,   170,
       8,     9,    10,    11,    12,   163,   164,   165,   320,   318,
     168,   318,   212,   195,    22,    23,    24,    25,    26,    27,
      28,    29,   103,    63,    32,    13,   180,    15,    16,    17,
      18,    19,    20,   952,    63,   152,   153,   178,    26,    27,
     186,    29,   322,    31,   963,   190,   163,   164,   165,   192,
     206,   168,   214,   210,   190,   216,   228,   137,   138,   139,
     140,   141,   142,   318,   144,   145,   146,   147,   221,   320,
     318,   320,    68,   320,   320,   922,   318,   320,    20,   926,
     927,   320,   320,    63,    63,   932,    74,   320,   318,   318,
     318,    66,    80,     8,     9,    10,    11,    12,   262,   320,
     318,   273,    68,    63,  1023,    66,   278,    22,    23,    24,
      25,    26,    27,    28,    29,    90,    91,    32,   316,   317,
    1172,    82,    83,    66,   318,   297,   324,    88,    89,   318,
      91,   318,  1087,    63,    20,   318,  1055,  1056,  1057,   318,
    1059,   313,   989,   990,   991,     3,   121,   122,   123,   124,
       3,     3,  1100,     3,  1102,     3,     3,     3,   316,     3,
       3,     3,     3,    20,   152,   153,   324,   318,   318,   318,
      15,  1119,  1120,  1121,   316,   163,   164,   165,    14,     7,
     168,    32,  1101,    63,    63,   318,    19,    26,   318,  1108,
    1109,    29,  1039,  1040,   219,  1042,    27,    46,    63,   316,
    1148,   318,     8,     9,    10,    11,    12,   324,   177,   177,
     187,   318,   318,    46,   318,   318,    22,    23,    24,    25,
      26,    27,    28,    29,   318,   318,    32,   318,  1147,  1177,
    1149,  1150,  1151,    63,  1153,  1154,    63,   317,    72,  1158,
    1195,    74,  1197,     8,     9,    10,    11,    12,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    22,    23,    24,
      25,    26,    27,    28,    29,  1184,  1185,    32,   244,   245,
     246,   247,   248,   249,   250,   251,  1224,   212,  1226,    19,
     318,   318,    84,   318,  1131,   318,   318,   184,   318,  1237,
    1209,     3,  1211,  1140,  1141,  1142,  1143,   130,   131,   132,
     133,   134,   135,   136,   318,   318,   318,   318,  1227,  1228,
     318,    19,  1231,  1232,  1233,   148,    74,    19,   151,  1238,
    1239,    19,    80,    20,   318,   318,    20,    85,   316,    87,
     320,    89,   318,    91,   317,    93,   324,    95,   322,     8,
       9,    10,    11,    12,     7,    15,    18,  1266,  1267,   316,
      27,   322,  1271,    22,    23,    24,    25,    26,    27,    28,
      29,   318,   318,    32,     8,     9,    10,    11,    12,   318,
     318,   318,   318,   318,   318,     3,     3,   318,    22,    23,
      24,    25,    26,    27,    28,    29,   318,   318,    32,   318,
       8,     9,    10,    11,    12,   318,   318,   318,  1245,   318,
     318,   318,   318,   318,    22,    23,    24,    25,    26,    27,
      28,    29,   318,   321,    32,     8,     9,    10,    11,    12,
     318,   321,   318,   318,   318,     3,     3,     3,   318,    22,
      23,    24,    25,    26,    27,    28,    29,   322,   270,    32,
       8,     9,    10,    11,    12,   322,   318,   318,   318,   318,
     318,   318,   318,   262,    22,    23,    24,    25,    26,    27,
      28,    29,   318,   318,    32,     8,     9,    10,    11,    12,
      20,     3,     3,    22,    15,    22,   192,     7,   318,    22,
      23,    24,    25,    26,    27,    28,    29,   320,   317,    32,
       8,     9,    10,    11,    12,   320,   320,   318,   316,   321,
     320,   318,   318,   318,    22,    23,    24,    25,    26,    27,
      28,    29,   318,     5,    32,     8,     9,    10,    11,    12,
     320,   318,   318,   322,   318,   317,   321,   318,   318,    22,
      23,    24,    25,    26,    27,    28,    29,   316,   318,    32,
       8,     9,    10,    11,    12,   317,   150,   316,   140,   316,
     316,   293,   316,   318,    22,    23,    24,    25,    26,    27,
      28,    29,   318,   318,    32,     8,     9,    10,    11,    12,
     318,   293,   318,   318,   321,     7,   320,    69,    70,    22,
      23,    24,    25,    26,    27,    28,    29,   322,   246,    32,
       8,     9,    10,    11,    12,   192,   188,   262,   264,   270,
     318,   293,   286,   281,    22,    23,    24,    25,    26,    27,
      28,    29,   285,     5,    32,     8,     9,    10,    11,    12,
     186,    63,   114,   318,   212,    19,   282,   289,   282,    22,
      23,    24,    25,    26,    27,    28,    29,   318,   318,    32,
       8,     9,    10,    11,    12,   106,   809,   205,   317,   842,
     318,   318,   789,   317,    22,    23,    24,    25,    26,    27,
      28,    29,   791,   318,    32,     8,     9,    10,    11,    12,
     262,   311,   357,   317,   500,   890,   814,    69,    70,    22,
      23,    24,    25,    26,    27,    28,    29,   279,   280,    32,
    1126,   283,   284,    85,   317,   287,   288,   588,   290,   317,
     651,  1195,  1197,   684,   196,   197,   198,   199,   200,   201,
     202,   203,  1042,   678,   832,   679,   930,   990,   823,   780,
    1172,    -1,   114,    -1,   317,    -1,    -1,    -1,    -1,   321,
     222,   223,    -1,    -1,    -1,    -1,    -1,    -1,   230,   231,
     232,   233,    -1,   137,   138,   139,   140,   141,   142,   317,
     144,   145,   146,   147,    -1,    -1,    41,    -1,    41,    -1,
      84,    -1,   154,   155,    -1,   157,   158,   159,   160,   161,
      -1,    -1,    -1,    -1,   317,    60,    61,    62,    -1,    64,
      65,   105,    -1,    68,    -1,    68,    71,    -1,    71,    74,
      75,    74,    75,    78,    79,    78,    79,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   196,   197,   198,   199,   200,   201,
     202,   203,    -1,    -1,    -1,    -1,    -1,    41,    -1,   311,
     312,   106,    46,   106,   317,   110,    -1,   110,    -1,    -1,
     222,   223,    -1,    -1,    -1,   118,    -1,    -1,   230,   231,
     232,   233,    41,    -1,    68,    -1,    -1,    71,    -1,   317,
      74,    75,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      84,    -1,    86,    41,    -1,    -1,    -1,    -1,    -1,    68,
     194,    -1,    71,    -1,   317,    74,    75,    -1,    77,    78,
      79,    -1,   106,    -1,    -1,    84,   110,    -1,    -1,    -1,
      68,    -1,    -1,    71,   118,    -1,    74,    75,    -1,   317,
      78,    79,   126,   127,    -1,   104,   105,   106,    -1,    -1,
      41,   110,    -1,    -1,   238,   239,   240,    -1,   242,   311,
     312,    -1,    -1,    -1,   317,    -1,    -1,    -1,   106,   253,
      -1,    -1,   110,    -1,   158,    -1,    -1,    68,    -1,    41,
      71,    -1,    -1,    74,    75,    -1,    77,    78,    79,   317,
      -1,   175,   176,    -1,   178,   179,    -1,   181,   182,   183,
      62,   185,    -1,    -1,   188,   189,    68,   191,    -1,    71,
      -1,    -1,    74,    75,   317,   106,    78,    79,   261,   110,
     204,   205,    -1,    41,    -1,   209,    -1,   211,    -1,   213,
      92,   215,    -1,    84,    -1,    -1,   220,   321,    -1,    -1,
     224,   225,    -1,   227,   106,    -1,    -1,    -1,   110,   140,
      68,    -1,    -1,    71,   105,    -1,    74,    75,    -1,    77,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   123,    -1,    -1,    -1,   321,    -1,   321,    -1,
      -1,    -1,    41,    -1,    -1,    -1,    -1,     3,   106,    -1,
      -1,   229,   110,    -1,   253,    -1,   234,    -1,   236,    58,
      59,    -1,    18,    19,   137,   138,   139,   140,   141,   142,
      -1,   144,   145,   146,   147,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,
      -1,   269,    -1,    -1,    -1,    -1,    -1,   321,    -1,   298,
     299,   300,   301,   194,    -1,    -1,    -1,    -1,   107,   308,
      -1,   110,    68,   112,    -1,    -1,   115,    73,    -1,    -1,
      -1,   120,   321,    79,    80,    -1,   125,   126,   127,   128,
      -1,    -1,    -1,    -1,    -1,    -1,    92,    93,    94,    95,
      -1,    97,    -1,   321,   235,    -1,   237,   238,   239,   240,
     241,   242,   243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   253,   254,    -1,    -1,   257,    -1,    -1,    -1,
     261,    -1,   263,    -1,    -1,    -1,    -1,    -1,   269,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
     321,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    -1,    -1,    -1,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,   173,    -1,   321,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
     321,    32,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,     8,     9,    10,
      -1,    -1,    -1,   321,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   327,   328,    41,    58,    59,   107,   110,   112,
     115,   120,   125,   126,   127,   128,   348,   349,   350,   389,
     390,   391,   392,   394,   395,   396,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   500,   501,   502,   503,   504,   505,
     506,   507,   541,   543,     0,     3,    33,    38,    41,    52,
      68,    71,    73,    80,    99,   110,   129,   174,   318,   330,
     338,   344,   347,   352,   354,   357,   359,   362,   363,   368,
     374,   375,   421,   423,   433,   469,   470,   471,   472,   508,
     509,   510,   513,   526,   527,   535,   536,   542,   544,   545,
     546,    19,    20,    40,   419,    20,    51,   351,     3,   108,
     109,   419,   419,     3,    90,    91,   113,   116,   118,   119,
     228,   313,    66,    90,    91,   121,   122,   123,   124,    15,
      35,    40,   408,   419,   419,   419,    19,    20,    39,    50,
     340,    90,    96,    38,    56,    73,   118,   345,   346,    19,
      72,    19,   100,    20,    90,    19,    13,    15,    16,    17,
      18,    19,    20,    26,    27,    29,    31,    74,    80,   152,
     153,   163,   164,   165,   168,   316,   324,   438,   448,   453,
     456,   457,   458,   460,   462,    19,   364,   364,    60,    65,
      76,   100,   228,   273,   278,   297,   313,   364,    41,    68,
      71,    74,    75,    77,    78,    79,   106,   110,   321,   365,
     377,   364,    46,    84,    86,   118,   126,   127,   158,   175,
     176,   178,   179,   181,   182,   183,   185,   188,   189,   191,
     204,   205,   209,   211,   213,   215,   220,   224,   225,   227,
     321,   365,   364,   229,   234,   236,   269,   321,   365,   473,
     474,   475,   364,   274,   275,   321,   365,   364,   321,   364,
      77,    84,   104,   105,   253,   298,   299,   300,   301,   308,
     321,   365,   384,   386,   387,   364,   118,   261,   321,   365,
     537,   540,    60,    61,    62,    64,    65,   321,   353,   356,
     365,    62,    92,   321,   355,   365,    35,    40,   320,   378,
     351,     3,   419,   419,     3,    35,    40,   320,   381,    19,
      20,    40,   420,     3,   117,     3,     3,   397,    19,   393,
      77,   123,   268,   271,   272,   393,   393,     3,     3,     3,
       3,     3,     3,     3,    15,   409,     3,     3,     3,    22,
      57,   339,    40,   320,   341,   378,    15,    19,   316,   329,
      20,    53,   318,    15,    17,    18,   358,   422,   360,   318,
     381,   434,    15,    19,    28,   316,   323,   452,   454,   460,
      29,   316,   172,   172,    15,   323,   455,   462,   316,   316,
     316,   316,   316,   462,    16,    17,   316,   329,   438,   439,
     443,   444,   446,   448,   449,   450,     5,    69,    70,    85,
     114,   154,   155,   157,   158,   159,   160,   161,   196,   197,
     198,   199,   200,   201,   202,   203,   222,   223,   230,   231,
     232,   233,   311,   312,   461,   547,     8,     9,    10,    11,
      12,    22,    23,    24,    25,    26,    27,    28,    29,    32,
     320,   320,   320,   378,    19,   367,    72,   329,    34,    35,
      36,    37,   329,   331,   376,    40,    80,    81,   173,   366,
     430,   366,    20,   381,   318,   318,   320,   193,   194,    20,
     331,   212,   195,   118,   208,   103,    18,    19,   177,   332,
     332,    63,   180,    63,   318,   329,   178,   186,   197,   198,
     190,   192,   206,   207,   206,   210,   331,   214,   216,   221,
      68,   190,    76,   226,   190,   318,   320,   358,   331,   329,
     331,   318,   320,   320,    68,   276,   277,   318,   320,   320,
     533,   534,    20,   329,   320,    81,   306,   307,   528,   329,
     329,    63,    63,   176,   309,   310,   318,   318,   320,   320,
     332,   333,   262,   318,   135,   184,   217,   314,   315,   318,
      68,   331,    63,   331,    66,   318,   318,   318,    63,    20,
     337,   318,   318,    66,    82,    83,    88,    89,    91,   379,
     380,     3,     3,     3,     3,    82,   111,   382,   383,     3,
     420,     3,     3,     3,    40,    68,    73,    79,    80,    92,
      93,    94,    95,    97,   333,   398,   430,     3,   393,   393,
     393,    40,   393,    40,   393,     3,     3,     3,    18,   329,
      20,    41,    42,    43,    44,    45,    46,    47,    48,    49,
     342,   343,   318,   462,   329,    54,    55,   318,   137,   138,
     139,   140,   141,   142,   144,   145,   146,   147,   424,   425,
     426,   428,   432,   101,   102,   103,   104,   318,   361,   318,
     316,   431,   454,   454,   462,   454,   454,    14,    15,   462,
     466,   467,    26,    27,   455,   455,    29,   462,   462,   462,
     462,   462,   317,   322,    28,   441,   442,   462,     7,   322,
     325,    26,    27,   320,   322,   325,   462,   462,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   139,
     156,   162,   169,   170,   358,   369,   372,   373,    19,   428,
     429,   462,    63,    63,   318,   318,   329,    46,   219,   331,
     332,   329,   177,   177,   329,    63,   329,   318,    63,   187,
     329,   329,   331,    63,   318,    72,   318,   331,   318,   331,
     187,   217,   218,   331,   367,   331,   318,   318,   331,   212,
     476,    19,   318,   318,   512,   373,   318,   318,   385,   386,
     318,   318,   318,   329,   329,   318,   318,   318,    72,    98,
     134,   388,    29,   319,   335,   331,    20,   332,   184,   538,
     539,   329,   329,   331,   329,   332,   333,   334,   321,   322,
     321,   322,     3,    19,    19,   429,   334,    19,    20,   499,
     499,   499,   393,   499,   393,   499,   318,   318,   321,   322,
     317,    20,    19,   143,   318,   320,   332,   329,   317,   425,
     427,   432,   317,   322,   317,   322,   317,   322,   322,   322,
     462,     7,   322,    18,   439,   444,    15,    18,   449,   316,
      27,   371,   322,   329,   329,   318,   331,   331,   318,   318,
     318,   329,   329,   318,   329,   318,   329,   318,   318,   318,
     318,   329,   358,   318,   318,   318,   318,   318,   318,   318,
     318,   318,   329,    77,   235,   258,   260,   267,   321,   477,
     482,   485,   318,    77,   140,   365,   511,   320,   532,   321,
     318,   318,   318,   329,    85,    87,    85,    87,   321,   329,
     332,   318,   332,   270,   538,   380,   383,     3,     3,     3,
     499,     3,   499,     3,   343,   426,    19,    46,    74,   130,
     131,   132,   133,   134,   135,   136,   148,   151,   435,   436,
     458,   459,   463,   468,   317,   318,   466,   462,   462,   462,
     462,   317,   441,   462,   442,   322,   462,    20,   334,   370,
     372,   318,   322,   318,   318,   318,   318,   318,   318,   318,
     318,   495,   498,   237,   331,   320,   262,   333,   478,   479,
     318,   320,   514,   519,   333,   520,   525,   318,   531,   385,
     318,    20,   336,   336,   336,   336,   329,     3,     3,    22,
     316,    22,   316,   462,   462,   462,   321,   468,   461,   547,
     318,   462,   464,   465,   425,   317,   317,   317,   317,   317,
      15,   317,   334,   329,   373,   329,   487,   358,   320,   483,
     373,   320,   524,   190,   275,   321,   530,   388,   318,   318,
     318,   318,   462,   467,   462,   458,   318,   149,   320,    22,
      22,    32,   322,   318,     7,   321,   318,   320,   497,   321,
     333,   488,   489,   490,   480,   194,   238,   239,   240,   242,
     253,   321,   384,   484,   320,   518,   523,   522,   329,   244,
     302,   303,   304,   305,   529,   318,   388,   388,   388,   388,
     318,   317,   318,   547,   320,   437,   468,   451,   462,   462,
      80,   164,   165,   168,   172,   465,   316,   496,   259,   318,
     117,   237,   259,   321,   481,   329,   329,   329,   192,    94,
     329,    81,   252,   255,   318,   517,   516,   291,   292,   294,
     295,   296,   321,   521,   317,   435,   150,     6,    15,    16,
      17,   316,   321,   438,   440,   443,   445,   447,   318,   318,
     316,   316,   316,   316,   318,   441,   123,   194,   235,   237,
     238,   239,   240,   241,   242,   243,   253,   254,   257,   261,
     263,   269,   321,   384,   486,   318,   331,   329,   331,   318,
     329,   329,   140,   188,   262,   279,   280,   283,   284,   287,
     288,   290,   321,   515,   293,   293,   331,   331,   331,   318,
     318,   321,   437,   435,   462,     7,   319,   322,   462,   462,
     462,   462,   322,   320,   329,   331,   329,   329,   329,   192,
     329,    94,   329,   244,   245,   246,   247,   248,   249,   250,
     251,    81,   252,   255,   246,   329,   262,   264,   270,   318,
     525,   293,   286,   192,   281,   281,   331,   285,    63,   289,
     186,   318,   329,   329,   317,   316,   440,   435,   445,   317,
     317,   317,   317,   441,   491,   329,   329,   331,   331,   265,
     266,   329,   329,   329,   329,   329,   282,   282,   331,   329,
     329,   212,   462,   318,   318,   318,   318,   317,    18,   321,
     492,   493,   494,   329,   329,   329,   256,   318,   318
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1806 of yacc.c  */
#line 445 "cf-parse.y"
    { return 0; }
    break;

  case 3:

/* Line 1806 of yacc.c  */
#line 446 "cf-parse.y"
    { return 0; }
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 459 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 8:

/* Line 1806 of yacc.c  */
#line 460 "cf-parse.y"
    { if ((yyvsp[(1) - (1)].s)->class != SYM_NUMBER) cf_error("Number expected"); else (yyval.i) = (yyvsp[(1) - (1)].s)->aux; }
    break;

  case 9:

/* Line 1806 of yacc.c  */
#line 466 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_NUMBER, NULL);
     (yyvsp[(2) - (5)].s)->aux = (yyvsp[(4) - (5)].i);
   }
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 470 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_IPA, cfg_alloc(sizeof(ip_addr)));
     *(ip_addr *)(yyvsp[(2) - (5)].s)->def = (yyvsp[(4) - (5)].a);
   }
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 479 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); }
    break;

  case 12:

/* Line 1806 of yacc.c  */
#line 480 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 481 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 482 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 483 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 484 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 491 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_IPA) cf_error("IP address expected");
     (yyval.a) = *(ip_addr *)(yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 498 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   }
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 506 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 510 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   }
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 514 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   }
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 521 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 529 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); }
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 530 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 536 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  }
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 545 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); }
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 546 "cf-parse.y"
    { (yyval.t) = bird_name; }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 550 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   }
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 555 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); }
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 556 "cf-parse.y"
    { (yyval.g) = stderr; }
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 560 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 561 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 565 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); }
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 566 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); }
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 570 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; }
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 571 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; }
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 572 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 573 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; }
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 574 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; }
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 575 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; }
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 576 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; }
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 577 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; }
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 578 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; }
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 584 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); }
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 585 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = fileno(f);
   }
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 594 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; }
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 595 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; }
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 596 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; }
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 597 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; }
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 600 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 601 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; }
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 602 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 603 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; }
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 615 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (3)].t), RECONFIG_HARD); }
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 618 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (4)].t), RECONFIG_SOFT); }
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 621 "cf-parse.y"
    { cmd_shutdown(); }
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 624 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 633 "cf-parse.y"
    {
#ifndef CONFIG_MULTIPLE_TABLES
     if (cf_krt)
       cf_error("Kernel protocol already defined");
#endif
     cf_krt = this_proto = proto_config_new(&proto_unix_kernel, sizeof(struct krt_config));
     this_proto->preference = DEF_PREF_INHERITED;
     THIS_KRT->scan_time = 60;
     THIS_KRT->learn = THIS_KRT->persist = 0;
     krt_scan_construct(THIS_KRT);
     krt_set_construct(THIS_KRT);
   }
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 649 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); }
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 650 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 654 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   }
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 661 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); }
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 667 "cf-parse.y"
    {
     if (cf_kif)
       cf_error("Kernel device protocol already defined");
     cf_kif = this_proto = proto_config_new(&proto_unix_iface, sizeof(struct kif_config));
     this_proto->preference = DEF_PREF_DIRECT;
     THIS_KIF->scan_time = 60;
     init_list(&THIS_KIF->primary);
     krt_if_construct(THIS_KIF);
   }
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 680 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 684 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 697 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->scan.table_id = (yyvsp[(3) - (3)].i);
   }
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 710 "cf-parse.y"
    {
   new_config->router_id = (yyvsp[(3) - (4)].i32);
   }
    break;

  case 72:

/* Line 1806 of yacc.c  */
#line 716 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); }
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 718 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
    break;

  case 78:

/* Line 1806 of yacc.c  */
#line 737 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); }
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 738 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); }
    break;

  case 80:

/* Line 1806 of yacc.c  */
#line 739 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; }
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 740 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; }
    break;

  case 82:

/* Line 1806 of yacc.c  */
#line 747 "cf-parse.y"
    {
   rt_new_table((yyvsp[(2) - (2)].s));
   }
    break;

  case 84:

/* Line 1806 of yacc.c  */
#line 759 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = SYM_PROTO;
     s->def = this_proto;
     this_proto->name = s->name;
     }
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 765 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), SYM_PROTO, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 87:

/* Line 1806 of yacc.c  */
#line 773 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   }
    break;

  case 88:

/* Line 1806 of yacc.c  */
#line 777 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); }
    break;

  case 89:

/* Line 1806 of yacc.c  */
#line 778 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); }
    break;

  case 90:

/* Line 1806 of yacc.c  */
#line 779 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); }
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 780 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 92:

/* Line 1806 of yacc.c  */
#line 781 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 782 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); }
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 783 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); }
    break;

  case 95:

/* Line 1806 of yacc.c  */
#line 784 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); }
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 788 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); }
    break;

  case 98:

/* Line 1806 of yacc.c  */
#line 790 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; }
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 791 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; }
    break;

  case 100:

/* Line 1806 of yacc.c  */
#line 795 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 101:

/* Line 1806 of yacc.c  */
#line 803 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 102:

/* Line 1806 of yacc.c  */
#line 804 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 812 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
    break;

  case 104:

/* Line 1806 of yacc.c  */
#line 820 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 821 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; }
    break;

  case 106:

/* Line 1806 of yacc.c  */
#line 822 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; }
    break;

  case 107:

/* Line 1806 of yacc.c  */
#line 826 "cf-parse.y"
    { this_ipn->positive = 1; }
    break;

  case 108:

/* Line 1806 of yacc.c  */
#line 827 "cf-parse.y"
    { this_ipn->positive = 0; }
    break;

  case 112:

/* Line 1806 of yacc.c  */
#line 844 "cf-parse.y"
    {
     struct rt_dev_config *p = proto_config_new(&proto_device, sizeof(struct rt_dev_config));
     this_proto = &p->c;
     p->c.preference = DEF_PREF_DIRECT;
     init_list(&p->iface_list);
   }
    break;

  case 116:

/* Line 1806 of yacc.c  */
#line 859 "cf-parse.y"
    {
     struct rt_dev_config *p = (void *) this_proto;
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&p->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
    break;

  case 118:

/* Line 1806 of yacc.c  */
#line 874 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 119:

/* Line 1806 of yacc.c  */
#line 875 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 876 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 881 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 885 "cf-parse.y"
    { (yyval.i) = D_STATES; }
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 886 "cf-parse.y"
    { (yyval.i) = D_ROUTES; }
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 887 "cf-parse.y"
    { (yyval.i) = D_FILTERS; }
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 888 "cf-parse.y"
    { (yyval.i) = D_IFACES; }
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 889 "cf-parse.y"
    { (yyval.i) = D_EVENTS; }
    break;

  case 128:

/* Line 1806 of yacc.c  */
#line 890 "cf-parse.y"
    { (yyval.i) = D_PACKETS; }
    break;

  case 129:

/* Line 1806 of yacc.c  */
#line 896 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 130:

/* Line 1806 of yacc.c  */
#line 897 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 898 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 903 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 134:

/* Line 1806 of yacc.c  */
#line 907 "cf-parse.y"
    { (yyval.i) = MD_STATES; }
    break;

  case 135:

/* Line 1806 of yacc.c  */
#line 908 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; }
    break;

  case 142:

/* Line 1806 of yacc.c  */
#line 929 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   }
    break;

  case 143:

/* Line 1806 of yacc.c  */
#line 947 "cf-parse.y"
    { }
    break;

  case 144:

/* Line 1806 of yacc.c  */
#line 948 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 145:

/* Line 1806 of yacc.c  */
#line 949 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); }
    break;

  case 146:

/* Line 1806 of yacc.c  */
#line 950 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 147:

/* Line 1806 of yacc.c  */
#line 951 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); }
    break;

  case 148:

/* Line 1806 of yacc.c  */
#line 952 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); }
    break;

  case 149:

/* Line 1806 of yacc.c  */
#line 961 "cf-parse.y"
    { cmd_show_status(); }
    break;

  case 150:

/* Line 1806 of yacc.c  */
#line 964 "cf-parse.y"
    { cmd_show_memory(); }
    break;

  case 151:

/* Line 1806 of yacc.c  */
#line 967 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); }
    break;

  case 152:

/* Line 1806 of yacc.c  */
#line 970 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); }
    break;

  case 154:

/* Line 1806 of yacc.c  */
#line 974 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 155:

/* Line 1806 of yacc.c  */
#line 978 "cf-parse.y"
    { if_show(); }
    break;

  case 156:

/* Line 1806 of yacc.c  */
#line 981 "cf-parse.y"
    { if_show_summary(); }
    break;

  case 157:

/* Line 1806 of yacc.c  */
#line 984 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); }
    break;

  case 158:

/* Line 1806 of yacc.c  */
#line 987 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
     (yyval.ra)->table = config->master_rtc->table;
   }
    break;

  case 159:

/* Line 1806 of yacc.c  */
#line 993 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   }
    break;

  case 160:

/* Line 1806 of yacc.c  */
#line 999 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   }
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 1006 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 162:

/* Line 1806 of yacc.c  */
#line 1011 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   }
    break;

  case 163:

/* Line 1806 of yacc.c  */
#line 1016 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   }
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 1021 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   }
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 1025 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   }
    break;

  case 166:

/* Line 1806 of yacc.c  */
#line 1029 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->primary_only = 1;
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 167:

/* Line 1806 of yacc.c  */
#line 1039 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 168:

/* Line 1806 of yacc.c  */
#line 1047 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   }
    break;

  case 169:

/* Line 1806 of yacc.c  */
#line 1051 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   }
    break;

  case 170:

/* Line 1806 of yacc.c  */
#line 1058 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 171:

/* Line 1806 of yacc.c  */
#line 1059 "cf-parse.y"
    { (yyval.i) = 2; }
    break;

  case 172:

/* Line 1806 of yacc.c  */
#line 1063 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].s)); }
    break;

  case 173:

/* Line 1806 of yacc.c  */
#line 1067 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); }
    break;

  case 174:

/* Line 1806 of yacc.c  */
#line 1069 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); }
    break;

  case 175:

/* Line 1806 of yacc.c  */
#line 1071 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); }
    break;

  case 176:

/* Line 1806 of yacc.c  */
#line 1073 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); }
    break;

  case 177:

/* Line 1806 of yacc.c  */
#line 1075 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); }
    break;

  case 178:

/* Line 1806 of yacc.c  */
#line 1077 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); }
    break;

  case 179:

/* Line 1806 of yacc.c  */
#line 1079 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); }
    break;

  case 180:

/* Line 1806 of yacc.c  */
#line 1081 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
}
    break;

  case 181:

/* Line 1806 of yacc.c  */
#line 1087 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 182:

/* Line 1806 of yacc.c  */
#line 1088 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 184:

/* Line 1806 of yacc.c  */
#line 1093 "cf-parse.y"
    { (yyval.i) = 4096; }
    break;

  case 185:

/* Line 1806 of yacc.c  */
#line 1094 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   }
    break;

  case 186:

/* Line 1806 of yacc.c  */
#line 1101 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_disable, 1, 0); }
    break;

  case 187:

/* Line 1806 of yacc.c  */
#line 1103 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_enable, 1, 0); }
    break;

  case 188:

/* Line 1806 of yacc.c  */
#line 1105 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_restart, 1, 0); }
    break;

  case 189:

/* Line 1806 of yacc.c  */
#line 1107 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); }
    break;

  case 190:

/* Line 1806 of yacc.c  */
#line 1109 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
    break;

  case 191:

/* Line 1806 of yacc.c  */
#line 1111 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
    break;

  case 192:

/* Line 1806 of yacc.c  */
#line 1115 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 193:

/* Line 1806 of yacc.c  */
#line 1119 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 194:

/* Line 1806 of yacc.c  */
#line 1122 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
    break;

  case 195:

/* Line 1806 of yacc.c  */
#line 1125 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 196:

/* Line 1806 of yacc.c  */
#line 1126 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 197:

/* Line 1806 of yacc.c  */
#line 1127 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 198:

/* Line 1806 of yacc.c  */
#line 1131 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 199:

/* Line 1806 of yacc.c  */
#line 1132 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 200:

/* Line 1806 of yacc.c  */
#line 1133 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 201:

/* Line 1806 of yacc.c  */
#line 1141 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); }
    break;

  case 202:

/* Line 1806 of yacc.c  */
#line 1142 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   }
    break;

  case 203:

/* Line 1806 of yacc.c  */
#line 1151 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); }
    break;

  case 204:

/* Line 1806 of yacc.c  */
#line 1155 "cf-parse.y"
    { (yyval.i) = T_INT; }
    break;

  case 205:

/* Line 1806 of yacc.c  */
#line 1156 "cf-parse.y"
    { (yyval.i) = T_BOOL; }
    break;

  case 206:

/* Line 1806 of yacc.c  */
#line 1157 "cf-parse.y"
    { (yyval.i) = T_IP; }
    break;

  case 207:

/* Line 1806 of yacc.c  */
#line 1158 "cf-parse.y"
    { (yyval.i) = T_PREFIX; }
    break;

  case 208:

/* Line 1806 of yacc.c  */
#line 1159 "cf-parse.y"
    { (yyval.i) = T_PAIR; }
    break;

  case 209:

/* Line 1806 of yacc.c  */
#line 1160 "cf-parse.y"
    { (yyval.i) = T_QUAD; }
    break;

  case 210:

/* Line 1806 of yacc.c  */
#line 1161 "cf-parse.y"
    { (yyval.i) = T_STRING; }
    break;

  case 211:

/* Line 1806 of yacc.c  */
#line 1162 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; }
    break;

  case 212:

/* Line 1806 of yacc.c  */
#line 1163 "cf-parse.y"
    { (yyval.i) = T_PATH; }
    break;

  case 213:

/* Line 1806 of yacc.c  */
#line 1164 "cf-parse.y"
    { (yyval.i) = T_CLIST; }
    break;

  case 214:

/* Line 1806 of yacc.c  */
#line 1165 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
    break;

  case 215:

/* Line 1806 of yacc.c  */
#line 1185 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val)); 
     val->type = (yyvsp[(1) - (2)].i); 
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   }
    break;

  case 216:

/* Line 1806 of yacc.c  */
#line 1196 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 217:

/* Line 1806 of yacc.c  */
#line 1197 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 218:

/* Line 1806 of yacc.c  */
#line 1204 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); }
    break;

  case 219:

/* Line 1806 of yacc.c  */
#line 1205 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 220:

/* Line 1806 of yacc.c  */
#line 1212 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   }
    break;

  case 221:

/* Line 1806 of yacc.c  */
#line 1221 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 223:

/* Line 1806 of yacc.c  */
#line 1229 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
    break;

  case 224:

/* Line 1806 of yacc.c  */
#line 1253 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); }
    break;

  case 225:

/* Line 1806 of yacc.c  */
#line 1254 "cf-parse.y"
    { (yyval.s)=NULL; }
    break;

  case 226:

/* Line 1806 of yacc.c  */
#line 1258 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   }
    break;

  case 227:

/* Line 1806 of yacc.c  */
#line 1271 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   }
    break;

  case 228:

/* Line 1806 of yacc.c  */
#line 1274 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   }
    break;

  case 229:

/* Line 1806 of yacc.c  */
#line 1287 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 230:

/* Line 1806 of yacc.c  */
#line 1288 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; }
    break;

  case 231:

/* Line 1806 of yacc.c  */
#line 1291 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); }
    break;

  case 232:

/* Line 1806 of yacc.c  */
#line 1292 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); }
    break;

  case 233:

/* Line 1806 of yacc.c  */
#line 1296 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   }
    break;

  case 234:

/* Line 1806 of yacc.c  */
#line 1299 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   }
    break;

  case 235:

/* Line 1806 of yacc.c  */
#line 1308 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); }
    break;

  case 236:

/* Line 1806 of yacc.c  */
#line 1321 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 237:

/* Line 1806 of yacc.c  */
#line 1322 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 238:

/* Line 1806 of yacc.c  */
#line 1323 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 239:

/* Line 1806 of yacc.c  */
#line 1324 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 240:

/* Line 1806 of yacc.c  */
#line 1328 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 241:

/* Line 1806 of yacc.c  */
#line 1329 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 242:

/* Line 1806 of yacc.c  */
#line 1330 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 243:

/* Line 1806 of yacc.c  */
#line 1331 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 244:

/* Line 1806 of yacc.c  */
#line 1332 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 245:

/* Line 1806 of yacc.c  */
#line 1336 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(1) - (1)].x)); check_u16((yyval.i)); }
    break;

  case 246:

/* Line 1806 of yacc.c  */
#line 1339 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (1)].i), (yyvsp[(1) - (1)].i)); }
    break;

  case 247:

/* Line 1806 of yacc.c  */
#line 1340 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (3)].i), (yyvsp[(3) - (3)].i)); }
    break;

  case 248:

/* Line 1806 of yacc.c  */
#line 1341 "cf-parse.y"
    { (yyval.i32) = 0xFFFF; }
    break;

  case 249:

/* Line 1806 of yacc.c  */
#line 1345 "cf-parse.y"
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[(2) - (5)].i32)), pair_b((yyvsp[(2) - (5)].i32)), pair_a((yyvsp[(4) - (5)].i32)), pair_b((yyvsp[(4) - (5)].i32)));
   }
    break;

  case 250:

/* Line 1806 of yacc.c  */
#line 1348 "cf-parse.y"
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[(2) - (11)].i32)) != pair_b((yyvsp[(2) - (11)].i32))) || (pair_a((yyvsp[(4) - (11)].i32)) != pair_b((yyvsp[(4) - (11)].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[(2) - (11)].i32)), pair_b((yyvsp[(4) - (11)].i32)), (yyvsp[(8) - (11)].i), (yyvsp[(10) - (11)].i)); 
   }
    break;

  case 252:

/* Line 1806 of yacc.c  */
#line 1358 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 253:

/* Line 1806 of yacc.c  */
#line 1359 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 255:

/* Line 1806 of yacc.c  */
#line 1364 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 256:

/* Line 1806 of yacc.c  */
#line 1365 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 258:

/* Line 1806 of yacc.c  */
#line 1370 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 260:

/* Line 1806 of yacc.c  */
#line 1375 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 261:

/* Line 1806 of yacc.c  */
#line 1379 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   }
    break;

  case 262:

/* Line 1806 of yacc.c  */
#line 1386 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 263:

/* Line 1806 of yacc.c  */
#line 1387 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; }
    break;

  case 264:

/* Line 1806 of yacc.c  */
#line 1388 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; }
    break;

  case 265:

/* Line 1806 of yacc.c  */
#line 1389 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   }
    break;

  case 266:

/* Line 1806 of yacc.c  */
#line 1396 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); }
    break;

  case 267:

/* Line 1806 of yacc.c  */
#line 1397 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); }
    break;

  case 268:

/* Line 1806 of yacc.c  */
#line 1400 "cf-parse.y"
    { (yyval.e) = NULL; }
    break;

  case 269:

/* Line 1806 of yacc.c  */
#line 1401 "cf-parse.y"
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[(2) - (4)].e); t; t = t->left)
       t->data = (yyvsp[(4) - (4)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (4)].e), (yyvsp[(2) - (4)].e));
   }
    break;

  case 270:

/* Line 1806 of yacc.c  */
#line 1408 "cf-parse.y"
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[(3) - (3)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), t);
 }
    break;

  case 271:

/* Line 1806 of yacc.c  */
#line 1420 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 272:

/* Line 1806 of yacc.c  */
#line 1421 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 273:

/* Line 1806 of yacc.c  */
#line 1425 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 274:

/* Line 1806 of yacc.c  */
#line 1426 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 275:

/* Line 1806 of yacc.c  */
#line 1430 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 276:

/* Line 1806 of yacc.c  */
#line 1431 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 277:

/* Line 1806 of yacc.c  */
#line 1432 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; }
    break;

  case 278:

/* Line 1806 of yacc.c  */
#line 1433 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); }
    break;

  case 279:

/* Line 1806 of yacc.c  */
#line 1434 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 280:

/* Line 1806 of yacc.c  */
#line 1438 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 281:

/* Line 1806 of yacc.c  */
#line 1439 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 282:

/* Line 1806 of yacc.c  */
#line 1440 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 283:

/* Line 1806 of yacc.c  */
#line 1444 "cf-parse.y"
    {
        if (((yyvsp[(2) - (5)].x)->code == 'c') && ((yyvsp[(4) - (5)].x)->code == 'c'))
          { 
            if (((yyvsp[(2) - (5)].x)->aux != T_INT) || ((yyvsp[(4) - (5)].x)->aux != T_INT))
              cf_error( "Can't operate with value of non-integer type in pair constructor" );
	    check_u16((yyvsp[(2) - (5)].x)->a2.i); check_u16((yyvsp[(4) - (5)].x)->a2.i);
            (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PAIR;  (yyval.x)->a2.i = pair((yyvsp[(2) - (5)].x)->a2.i, (yyvsp[(4) - (5)].x)->a2.i);
          }
	else
	  { (yyval.x) = f_new_inst(); (yyval.x)->code = P('m', 'p'); (yyval.x)->a1.p = (yyvsp[(2) - (5)].x); (yyval.x)->a2.p = (yyvsp[(4) - (5)].x); }
    }
    break;

  case 284:

/* Line 1806 of yacc.c  */
#line 1458 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); }
    break;

  case 285:

/* Line 1806 of yacc.c  */
#line 1459 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
    break;

  case 286:

/* Line 1806 of yacc.c  */
#line 1460 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
    break;

  case 287:

/* Line 1806 of yacc.c  */
#line 1461 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); }
    break;

  case 288:

/* Line 1806 of yacc.c  */
#line 1462 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 289:

/* Line 1806 of yacc.c  */
#line 1463 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 290:

/* Line 1806 of yacc.c  */
#line 1464 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 291:

/* Line 1806 of yacc.c  */
#line 1465 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); }
    break;

  case 292:

/* Line 1806 of yacc.c  */
#line 1466 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); }
    break;

  case 293:

/* Line 1806 of yacc.c  */
#line 1467 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; }
    break;

  case 294:

/* Line 1806 of yacc.c  */
#line 1468 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; }
    break;

  case 296:

/* Line 1806 of yacc.c  */
#line 1482 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 297:

/* Line 1806 of yacc.c  */
#line 1505 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     switch ((yyvsp[(1) - (1)].s)->class) {
       case SYM_NUMBER:
	(yyval.x) = f_new_inst();
	(yyval.x)->code = 'c'; 
	(yyval.x)->aux = T_INT; 
	(yyval.x)->a2.i = (yyvsp[(1) - (1)].s)->aux;
	break;
       case SYM_IPA:
	{ NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; val->type = T_IP; val->val.px.ip = * (ip_addr *) ((yyvsp[(1) - (1)].s)->def); }
	break;
       case SYM_VARIABLE | T_BOOL:
       case SYM_VARIABLE | T_INT:
       case SYM_VARIABLE | T_PAIR:
       case SYM_VARIABLE | T_QUAD:
       case SYM_VARIABLE | T_STRING:
       case SYM_VARIABLE | T_IP:
       case SYM_VARIABLE | T_PREFIX:
       case SYM_VARIABLE | T_PREFIX_SET:
       case SYM_VARIABLE | T_SET:
       case SYM_VARIABLE | T_PATH:
       case SYM_VARIABLE | T_PATH_MASK:
       case SYM_VARIABLE | T_CLIST:
	 (yyval.x)->code = 'V';
	 (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
	 (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
	 break;
       default:
	 cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name );
     }
   }
    break;

  case 298:

/* Line 1806 of yacc.c  */
#line 1539 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, from);   (yyval.x)->a1.i = 1; }
    break;

  case 299:

/* Line 1806 of yacc.c  */
#line 1541 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, gw);     (yyval.x)->a1.i = 1; }
    break;

  case 300:

/* Line 1806 of yacc.c  */
#line 1542 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = 0x12345678; /* This is actually ok - T_PREFIX is special-cased. */ }
    break;

  case 301:

/* Line 1806 of yacc.c  */
#line 1543 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = 0x12345678; /* T_STRING is also special-cased. */ }
    break;

  case 302:

/* Line 1806 of yacc.c  */
#line 1544 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = OFFSETOF(struct rta, source); }
    break;

  case 303:

/* Line 1806 of yacc.c  */
#line 1545 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = OFFSETOF(struct rta, scope);  (yyval.x)->a1.i = 1; }
    break;

  case 304:

/* Line 1806 of yacc.c  */
#line 1546 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = OFFSETOF(struct rta, cast); }
    break;

  case 305:

/* Line 1806 of yacc.c  */
#line 1547 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = OFFSETOF(struct rta, dest); }
    break;

  case 306:

/* Line 1806 of yacc.c  */
#line 1551 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 307:

/* Line 1806 of yacc.c  */
#line 1552 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 308:

/* Line 1806 of yacc.c  */
#line 1553 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 309:

/* Line 1806 of yacc.c  */
#line 1554 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 310:

/* Line 1806 of yacc.c  */
#line 1555 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 311:

/* Line 1806 of yacc.c  */
#line 1556 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 312:

/* Line 1806 of yacc.c  */
#line 1557 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 313:

/* Line 1806 of yacc.c  */
#line 1558 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 314:

/* Line 1806 of yacc.c  */
#line 1559 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 315:

/* Line 1806 of yacc.c  */
#line 1560 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 316:

/* Line 1806 of yacc.c  */
#line 1561 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 317:

/* Line 1806 of yacc.c  */
#line 1562 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 318:

/* Line 1806 of yacc.c  */
#line 1563 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 319:

/* Line 1806 of yacc.c  */
#line 1564 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 320:

/* Line 1806 of yacc.c  */
#line 1565 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); }
    break;

  case 321:

/* Line 1806 of yacc.c  */
#line 1566 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); }
    break;

  case 322:

/* Line 1806 of yacc.c  */
#line 1568 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 323:

/* Line 1806 of yacc.c  */
#line 1569 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 324:

/* Line 1806 of yacc.c  */
#line 1570 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 325:

/* Line 1806 of yacc.c  */
#line 1572 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
    break;

  case 326:

/* Line 1806 of yacc.c  */
#line 1574 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; }
    break;

  case 327:

/* Line 1806 of yacc.c  */
#line 1576 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); }
    break;

  case 328:

/* Line 1806 of yacc.c  */
#line 1578 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; }
    break;

  case 329:

/* Line 1806 of yacc.c  */
#line 1579 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 330:

/* Line 1806 of yacc.c  */
#line 1580 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 331:

/* Line 1806 of yacc.c  */
#line 1581 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 332:

/* Line 1806 of yacc.c  */
#line 1582 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 333:

/* Line 1806 of yacc.c  */
#line 1592 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
    break;

  case 334:

/* Line 1806 of yacc.c  */
#line 1593 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
    break;

  case 335:

/* Line 1806 of yacc.c  */
#line 1594 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 336:

/* Line 1806 of yacc.c  */
#line 1595 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; }
    break;

  case 337:

/* Line 1806 of yacc.c  */
#line 1596 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; }
    break;

  case 338:

/* Line 1806 of yacc.c  */
#line 1597 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'f'; }
    break;

  case 339:

/* Line 1806 of yacc.c  */
#line 1602 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 340:

/* Line 1806 of yacc.c  */
#line 1625 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; }
    break;

  case 341:

/* Line 1806 of yacc.c  */
#line 1626 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; }
    break;

  case 342:

/* Line 1806 of yacc.c  */
#line 1627 "cf-parse.y"
    { (yyval.i) = F_REJECT; }
    break;

  case 343:

/* Line 1806 of yacc.c  */
#line 1628 "cf-parse.y"
    { (yyval.i) = F_ERROR; }
    break;

  case 344:

/* Line 1806 of yacc.c  */
#line 1629 "cf-parse.y"
    { (yyval.i) = F_NOP; }
    break;

  case 345:

/* Line 1806 of yacc.c  */
#line 1630 "cf-parse.y"
    { (yyval.i) = F_NONL; }
    break;

  case 346:

/* Line 1806 of yacc.c  */
#line 1634 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; }
    break;

  case 347:

/* Line 1806 of yacc.c  */
#line 1637 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 348:

/* Line 1806 of yacc.c  */
#line 1638 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 349:

/* Line 1806 of yacc.c  */
#line 1639 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   }
    break;

  case 350:

/* Line 1806 of yacc.c  */
#line 1648 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   }
    break;

  case 351:

/* Line 1806 of yacc.c  */
#line 1655 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   }
    break;

  case 352:

/* Line 1806 of yacc.c  */
#line 1664 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 353:

/* Line 1806 of yacc.c  */
#line 1665 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 354:

/* Line 1806 of yacc.c  */
#line 1669 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   }
    break;

  case 355:

/* Line 1806 of yacc.c  */
#line 1675 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   }
    break;

  case 356:

/* Line 1806 of yacc.c  */
#line 1685 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 357:

/* Line 1806 of yacc.c  */
#line 1694 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   }
    break;

  case 358:

/* Line 1806 of yacc.c  */
#line 1700 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 359:

/* Line 1806 of yacc.c  */
#line 1705 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 360:

/* Line 1806 of yacc.c  */
#line 1712 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 361:

/* Line 1806 of yacc.c  */
#line 1717 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
    break;

  case 362:

/* Line 1806 of yacc.c  */
#line 1723 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); }
    break;

  case 363:

/* Line 1806 of yacc.c  */
#line 1724 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); }
    break;

  case 364:

/* Line 1806 of yacc.c  */
#line 1725 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   }
    break;

  case 365:

/* Line 1806 of yacc.c  */
#line 1734 "cf-parse.y"
    { struct f_inst *i = f_new_inst(); i->code = 'E'; i->aux = T_CLIST; (yyval.x) = (yyvsp[(2) - (5)].x); (yyval.x)->code = P('e','S'); (yyval.x)->a1.p = i; }
    break;

  case 366:

/* Line 1806 of yacc.c  */
#line 1735 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 367:

/* Line 1806 of yacc.c  */
#line 1736 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 368:

/* Line 1806 of yacc.c  */
#line 1737 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 369:

/* Line 1806 of yacc.c  */
#line 1738 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 370:

/* Line 1806 of yacc.c  */
#line 1744 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config));
     this_proto->preference = DEF_PREF_BGP;
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
 }
    break;

  case 373:

/* Line 1806 of yacc.c  */
#line 1768 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); }
    break;

  case 374:

/* Line 1806 of yacc.c  */
#line 1769 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 375:

/* Line 1806 of yacc.c  */
#line 1770 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip)) cf_error("Only one neighbor per BGP instance is allowed");

     BGP_CFG->remote_ip = (yyvsp[(3) - (6)].a);
     BGP_CFG->remote_as = (yyvsp[(5) - (6)].i);
   }
    break;

  case 376:

/* Line 1806 of yacc.c  */
#line 1776 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); }
    break;

  case 377:

/* Line 1806 of yacc.c  */
#line 1777 "cf-parse.y"
    { BGP_CFG->rr_client = 1; }
    break;

  case 378:

/* Line 1806 of yacc.c  */
#line 1778 "cf-parse.y"
    { BGP_CFG->rs_client = 1; }
    break;

  case 379:

/* Line 1806 of yacc.c  */
#line 1779 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); }
    break;

  case 380:

/* Line 1806 of yacc.c  */
#line 1780 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); }
    break;

  case 381:

/* Line 1806 of yacc.c  */
#line 1781 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); }
    break;

  case 382:

/* Line 1806 of yacc.c  */
#line 1782 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); }
    break;

  case 383:

/* Line 1806 of yacc.c  */
#line 1783 "cf-parse.y"
    { BGP_CFG->multihop = 64; }
    break;

  case 384:

/* Line 1806 of yacc.c  */
#line 1784 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); }
    break;

  case 385:

/* Line 1806 of yacc.c  */
#line 1785 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; }
    break;

  case 386:

/* Line 1806 of yacc.c  */
#line 1786 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; }
    break;

  case 387:

/* Line 1806 of yacc.c  */
#line 1787 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; }
    break;

  case 388:

/* Line 1806 of yacc.c  */
#line 1788 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
    break;

  case 389:

/* Line 1806 of yacc.c  */
#line 1789 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; }
    break;

  case 390:

/* Line 1806 of yacc.c  */
#line 1790 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
    break;

  case 391:

/* Line 1806 of yacc.c  */
#line 1791 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); }
    break;

  case 392:

/* Line 1806 of yacc.c  */
#line 1792 "cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 393:

/* Line 1806 of yacc.c  */
#line 1793 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 394:

/* Line 1806 of yacc.c  */
#line 1794 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); }
    break;

  case 395:

/* Line 1806 of yacc.c  */
#line 1795 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); }
    break;

  case 396:

/* Line 1806 of yacc.c  */
#line 1796 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); }
    break;

  case 397:

/* Line 1806 of yacc.c  */
#line 1797 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); }
    break;

  case 398:

/* Line 1806 of yacc.c  */
#line 1798 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); }
    break;

  case 399:

/* Line 1806 of yacc.c  */
#line 1799 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); }
    break;

  case 400:

/* Line 1806 of yacc.c  */
#line 1800 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); }
    break;

  case 401:

/* Line 1806 of yacc.c  */
#line 1801 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); }
    break;

  case 402:

/* Line 1806 of yacc.c  */
#line 1802 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); }
    break;

  case 403:

/* Line 1806 of yacc.c  */
#line 1803 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); }
    break;

  case 404:

/* Line 1806 of yacc.c  */
#line 1804 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); }
    break;

  case 405:

/* Line 1806 of yacc.c  */
#line 1805 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); }
    break;

  case 406:

/* Line 1806 of yacc.c  */
#line 1806 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); }
    break;

  case 407:

/* Line 1806 of yacc.c  */
#line 1807 "cf-parse.y"
    { BGP_CFG->route_limit = (yyvsp[(4) - (5)].i); }
    break;

  case 408:

/* Line 1806 of yacc.c  */
#line 1808 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); }
    break;

  case 409:

/* Line 1806 of yacc.c  */
#line 1809 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); }
    break;

  case 410:

/* Line 1806 of yacc.c  */
#line 1810 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 411:

/* Line 1806 of yacc.c  */
#line 1820 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config));
     this_proto->preference = DEF_PREF_OSPF;
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  }
    break;

  case 415:

/* Line 1806 of yacc.c  */
#line 1837 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); }
    break;

  case 416:

/* Line 1806 of yacc.c  */
#line 1838 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 417:

/* Line 1806 of yacc.c  */
#line 1839 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 418:

/* Line 1806 of yacc.c  */
#line 1840 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); }
    break;

  case 420:

/* Line 1806 of yacc.c  */
#line 1844 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->stub = 0;
  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->stubnet_list);
 }
    break;

  case 421:

/* Line 1806 of yacc.c  */
#line 1855 "cf-parse.y"
    { ospf_area_finish(); }
    break;

  case 424:

/* Line 1806 of yacc.c  */
#line 1864 "cf-parse.y"
    { this_area->stub = (yyvsp[(3) - (3)].i) ; if((yyvsp[(3) - (3)].i)<=0) cf_error("Stub cost must be greater than zero"); }
    break;

  case 425:

/* Line 1806 of yacc.c  */
#line 1865 "cf-parse.y"
    {if((yyvsp[(2) - (2)].i)) { if(!this_area->stub) this_area->stub=DEFAULT_STUB_COST;}else{ this_area->stub=0;}}
    break;

  case 432:

/* Line 1806 of yacc.c  */
#line 1878 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   }
    break;

  case 435:

/* Line 1806 of yacc.c  */
#line 1892 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); }
    break;

  case 436:

/* Line 1806 of yacc.c  */
#line 1893 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 437:

/* Line 1806 of yacc.c  */
#line 1894 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); }
    break;

  case 438:

/* Line 1806 of yacc.c  */
#line 1898 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 443:

/* Line 1806 of yacc.c  */
#line 1908 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 444:

/* Line 1806 of yacc.c  */
#line 1909 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 445:

/* Line 1806 of yacc.c  */
#line 1910 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 446:

/* Line 1806 of yacc.c  */
#line 1911 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 447:

/* Line 1806 of yacc.c  */
#line 1912 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 448:

/* Line 1806 of yacc.c  */
#line 1913 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 449:

/* Line 1806 of yacc.c  */
#line 1914 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 450:

/* Line 1806 of yacc.c  */
#line 1915 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 451:

/* Line 1806 of yacc.c  */
#line 1916 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 453:

/* Line 1806 of yacc.c  */
#line 1921 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 }
    break;

  case 454:

/* Line 1806 of yacc.c  */
#line 1942 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); }
    break;

  case 455:

/* Line 1806 of yacc.c  */
#line 1943 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 456:

/* Line 1806 of yacc.c  */
#line 1944 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); }
    break;

  case 457:

/* Line 1806 of yacc.c  */
#line 1945 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 458:

/* Line 1806 of yacc.c  */
#line 1946 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 459:

/* Line 1806 of yacc.c  */
#line 1947 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 460:

/* Line 1806 of yacc.c  */
#line 1948 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 461:

/* Line 1806 of yacc.c  */
#line 1949 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 462:

/* Line 1806 of yacc.c  */
#line 1950 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 463:

/* Line 1806 of yacc.c  */
#line 1951 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 464:

/* Line 1806 of yacc.c  */
#line 1952 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 465:

/* Line 1806 of yacc.c  */
#line 1953 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 466:

/* Line 1806 of yacc.c  */
#line 1954 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 467:

/* Line 1806 of yacc.c  */
#line 1955 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 468:

/* Line 1806 of yacc.c  */
#line 1956 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 469:

/* Line 1806 of yacc.c  */
#line 1957 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 470:

/* Line 1806 of yacc.c  */
#line 1958 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); }
    break;

  case 471:

/* Line 1806 of yacc.c  */
#line 1959 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; }
    break;

  case 472:

/* Line 1806 of yacc.c  */
#line 1960 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; }
    break;

  case 473:

/* Line 1806 of yacc.c  */
#line 1961 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 474:

/* Line 1806 of yacc.c  */
#line 1962 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 476:

/* Line 1806 of yacc.c  */
#line 1964 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 477:

/* Line 1806 of yacc.c  */
#line 1965 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 478:

/* Line 1806 of yacc.c  */
#line 1966 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 479:

/* Line 1806 of yacc.c  */
#line 1967 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_LARGE ; }
    break;

  case 480:

/* Line 1806 of yacc.c  */
#line 1968 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_NORMAL ; }
    break;

  case 481:

/* Line 1806 of yacc.c  */
#line 1969 "cf-parse.y"
    { OSPF_PATT->rxbuf = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i) < OSPF_RXBUF_MINSIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
    break;

  case 487:

/* Line 1806 of yacc.c  */
#line 1983 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(&this_area->net_list, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (2)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (2)].px).len;
 }
    break;

  case 488:

/* Line 1806 of yacc.c  */
#line 1992 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(&this_area->net_list, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (3)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (3)].px).len;
   this_pref->hidden = 1;
 }
    break;

  case 493:

/* Line 1806 of yacc.c  */
#line 2011 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (2)].a);
   this_nbma->eligible=0;
 }
    break;

  case 494:

/* Line 1806 of yacc.c  */
#line 2020 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=1;
 }
    break;

  case 495:

/* Line 1806 of yacc.c  */
#line 2030 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 }
    break;

  case 500:

/* Line 1806 of yacc.c  */
#line 2061 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 502:

/* Line 1806 of yacc.c  */
#line 2066 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 503:

/* Line 1806 of yacc.c  */
#line 2071 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); }
    break;

  case 504:

/* Line 1806 of yacc.c  */
#line 2074 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 505:

/* Line 1806 of yacc.c  */
#line 2077 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 506:

/* Line 1806 of yacc.c  */
#line 2082 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); }
    break;

  case 507:

/* Line 1806 of yacc.c  */
#line 2085 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); }
    break;

  case 508:

/* Line 1806 of yacc.c  */
#line 2090 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); }
    break;

  case 509:

/* Line 1806 of yacc.c  */
#line 2093 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); }
    break;

  case 510:

/* Line 1806 of yacc.c  */
#line 2096 "cf-parse.y"
    { ospf_sh_lsadb(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf)); }
    break;

  case 511:

/* Line 1806 of yacc.c  */
#line 2101 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config));
     this_proto->preference = DEF_PREF_PIPE;
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
    break;

  case 514:

/* Line 1806 of yacc.c  */
#line 2111 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   }
    break;

  case 515:

/* Line 1806 of yacc.c  */
#line 2116 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; }
    break;

  case 516:

/* Line 1806 of yacc.c  */
#line 2117 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
    break;

  case 517:

/* Line 1806 of yacc.c  */
#line 2124 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_radv, sizeof(struct radv_config));
  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
}
    break;

  case 519:

/* Line 1806 of yacc.c  */
#line 2132 "cf-parse.y"
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
    break;

  case 524:

/* Line 1806 of yacc.c  */
#line 2146 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);

  RADV_IFACE->min_ra_int = -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = -1;
}
    break;

  case 525:

/* Line 1806 of yacc.c  */
#line 2160 "cf-parse.y"
    { RADV_IFACE->min_ra_int = (yyvsp[(4) - (4)].i); if ((yyvsp[(4) - (4)].i) < 3) cf_error("Min RA interval must be at least 3"); }
    break;

  case 526:

/* Line 1806 of yacc.c  */
#line 2161 "cf-parse.y"
    { RADV_IFACE->max_ra_int = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 4) || ((yyvsp[(4) - (4)].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
    break;

  case 527:

/* Line 1806 of yacc.c  */
#line 2162 "cf-parse.y"
    { RADV_IFACE->min_delay = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) <= 0) cf_error("Min delay must be positive"); }
    break;

  case 528:

/* Line 1806 of yacc.c  */
#line 2163 "cf-parse.y"
    { RADV_IFACE->managed = (yyvsp[(2) - (2)].i); }
    break;

  case 529:

/* Line 1806 of yacc.c  */
#line 2164 "cf-parse.y"
    { RADV_IFACE->other_config = (yyvsp[(3) - (3)].i); }
    break;

  case 530:

/* Line 1806 of yacc.c  */
#line 2165 "cf-parse.y"
    { RADV_IFACE->link_mtu = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Link MTU must be 0 or positive"); }
    break;

  case 531:

/* Line 1806 of yacc.c  */
#line 2166 "cf-parse.y"
    { RADV_IFACE->reachable_time = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > 3600000)) cf_error("Reachable time must be in range 0-3600000"); }
    break;

  case 532:

/* Line 1806 of yacc.c  */
#line 2167 "cf-parse.y"
    { RADV_IFACE->retrans_timer = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Retrans timer must be 0 or positive"); }
    break;

  case 533:

/* Line 1806 of yacc.c  */
#line 2168 "cf-parse.y"
    { RADV_IFACE->current_hop_limit = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 0) || ((yyvsp[(4) - (4)].i) > 255))  cf_error("Current hop limit must be in range 0-255"); }
    break;

  case 534:

/* Line 1806 of yacc.c  */
#line 2169 "cf-parse.y"
    { RADV_IFACE->default_lifetime = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > 9000))  cf_error("Default lifetime must be in range 0-9000"); }
    break;

  case 535:

/* Line 1806 of yacc.c  */
#line 2170 "cf-parse.y"
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
    break;

  case 536:

/* Line 1806 of yacc.c  */
#line 2174 "cf-parse.y"
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = _MAX(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval %d %d", ic->min_ra_int, ic->max_ra_int);

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");
}
    break;

  case 542:

/* Line 1806 of yacc.c  */
#line 2207 "cf-parse.y"
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = (yyvsp[(1) - (1)].px).addr;
  RADV_PREFIX->pxlen = (yyvsp[(1) - (1)].px).len;

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
    break;

  case 543:

/* Line 1806 of yacc.c  */
#line 2219 "cf-parse.y"
    { RADV_PREFIX->skip = (yyvsp[(2) - (2)].i); }
    break;

  case 544:

/* Line 1806 of yacc.c  */
#line 2220 "cf-parse.y"
    { RADV_PREFIX->onlink = (yyvsp[(2) - (2)].i); }
    break;

  case 545:

/* Line 1806 of yacc.c  */
#line 2221 "cf-parse.y"
    { RADV_PREFIX->autonomous = (yyvsp[(2) - (2)].i); }
    break;

  case 546:

/* Line 1806 of yacc.c  */
#line 2222 "cf-parse.y"
    { RADV_PREFIX->valid_lifetime = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Valid lifetime must be 0 or positive"); }
    break;

  case 547:

/* Line 1806 of yacc.c  */
#line 2223 "cf-parse.y"
    { RADV_PREFIX->preferred_lifetime = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Preferred lifetime must be 0 or positive"); }
    break;

  case 548:

/* Line 1806 of yacc.c  */
#line 2227 "cf-parse.y"
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");
}
    break;

  case 554:

/* Line 1806 of yacc.c  */
#line 2249 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config));
     rip_init_config(RIP_CFG);
   }
    break;

  case 557:

/* Line 1806 of yacc.c  */
#line 2258 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); }
    break;

  case 558:

/* Line 1806 of yacc.c  */
#line 2259 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); }
    break;

  case 559:

/* Line 1806 of yacc.c  */
#line 2260 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); }
    break;

  case 560:

/* Line 1806 of yacc.c  */
#line 2261 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); }
    break;

  case 561:

/* Line 1806 of yacc.c  */
#line 2262 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); }
    break;

  case 562:

/* Line 1806 of yacc.c  */
#line 2263 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); }
    break;

  case 564:

/* Line 1806 of yacc.c  */
#line 2265 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; }
    break;

  case 565:

/* Line 1806 of yacc.c  */
#line 2266 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; }
    break;

  case 566:

/* Line 1806 of yacc.c  */
#line 2267 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; }
    break;

  case 568:

/* Line 1806 of yacc.c  */
#line 2272 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; }
    break;

  case 569:

/* Line 1806 of yacc.c  */
#line 2273 "cf-parse.y"
    { (yyval.i)=AT_MD5; }
    break;

  case 570:

/* Line 1806 of yacc.c  */
#line 2274 "cf-parse.y"
    { (yyval.i)=AT_NONE; }
    break;

  case 571:

/* Line 1806 of yacc.c  */
#line 2279 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; }
    break;

  case 572:

/* Line 1806 of yacc.c  */
#line 2280 "cf-parse.y"
    { (yyval.i)=0; }
    break;

  case 573:

/* Line 1806 of yacc.c  */
#line 2281 "cf-parse.y"
    { (yyval.i)=IM_QUIET; }
    break;

  case 574:

/* Line 1806 of yacc.c  */
#line 2282 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; }
    break;

  case 575:

/* Line 1806 of yacc.c  */
#line 2283 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; }
    break;

  case 577:

/* Line 1806 of yacc.c  */
#line 2287 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); }
    break;

  case 578:

/* Line 1806 of yacc.c  */
#line 2288 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); }
    break;

  case 583:

/* Line 1806 of yacc.c  */
#line 2302 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
   }
    break;

  case 585:

/* Line 1806 of yacc.c  */
#line 2318 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config));
     static_init_config((struct static_config *) this_proto);
  }
    break;

  case 588:

/* Line 1806 of yacc.c  */
#line 2327 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 590:

/* Line 1806 of yacc.c  */
#line 2331 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  }
    break;

  case 591:

/* Line 1806 of yacc.c  */
#line 2340 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (2)].a);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   }
    break;

  case 592:

/* Line 1806 of yacc.c  */
#line 2347 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
    break;

  case 593:

/* Line 1806 of yacc.c  */
#line 2354 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; }
    break;

  case 594:

/* Line 1806 of yacc.c  */
#line 2355 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; }
    break;

  case 595:

/* Line 1806 of yacc.c  */
#line 2359 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (3)].a);
   }
    break;

  case 596:

/* Line 1806 of yacc.c  */
#line 2363 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
    break;

  case 597:

/* Line 1806 of yacc.c  */
#line 2369 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   }
    break;

  case 598:

/* Line 1806 of yacc.c  */
#line 2372 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 599:

/* Line 1806 of yacc.c  */
#line 2373 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 600:

/* Line 1806 of yacc.c  */
#line 2374 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; }
    break;

  case 601:

/* Line 1806 of yacc.c  */
#line 2378 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); }
    break;

  case 655:

/* Line 1806 of yacc.c  */
#line 2386 "cf-parse.y"
    { bgp_check(BGP_CFG); }
    break;

  case 656:

/* Line 1806 of yacc.c  */
#line 2386 "cf-parse.y"
    { ospf_proto_finish(); }
    break;

  case 659:

/* Line 1806 of yacc.c  */
#line 2386 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); }
    break;

  case 668:

/* Line 1806 of yacc.c  */
#line 2389 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
    break;

  case 669:

/* Line 1806 of yacc.c  */
#line 2389 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
    break;

  case 670:

/* Line 1806 of yacc.c  */
#line 2390 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
    break;

  case 671:

/* Line 1806 of yacc.c  */
#line 2390 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 672:

/* Line 1806 of yacc.c  */
#line 2391 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
    break;

  case 673:

/* Line 1806 of yacc.c  */
#line 2392 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
    break;

  case 674:

/* Line 1806 of yacc.c  */
#line 2393 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
    break;

  case 675:

/* Line 1806 of yacc.c  */
#line 2394 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
    break;

  case 676:

/* Line 1806 of yacc.c  */
#line 2395 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
    break;

  case 677:

/* Line 1806 of yacc.c  */
#line 2396 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
    break;

  case 678:

/* Line 1806 of yacc.c  */
#line 2397 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
    break;

  case 679:

/* Line 1806 of yacc.c  */
#line 2398 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
    break;

  case 680:

/* Line 1806 of yacc.c  */
#line 2399 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
    break;

  case 681:

/* Line 1806 of yacc.c  */
#line 2400 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
    break;

  case 682:

/* Line 1806 of yacc.c  */
#line 2400 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
    break;

  case 683:

/* Line 1806 of yacc.c  */
#line 2400 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
    break;

  case 684:

/* Line 1806 of yacc.c  */
#line 2400 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
    break;

  case 685:

/* Line 1806 of yacc.c  */
#line 2400 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
    break;

  case 686:

/* Line 1806 of yacc.c  */
#line 2400 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
    break;

  case 687:

/* Line 1806 of yacc.c  */
#line 2400 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
    break;



/* Line 1806 of yacc.c  */
#line 7715 "cf-parse.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 2402 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/radv/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */


